#include "alfabet.h"
#include "dupa.h"

Alfabet::Alfabet()
{
    nie_ma_polskich = false; // Tzn. zakladam, ze uzytkownik ma dobrze skonfigurowanego XSerwera

    for( int i=0; i<256; i++ )
	punktyLiter[i] = 0;

    punktyLiter[ 'a' ] = 1;
    punktyLiter[ 'b' ] = 3;
    punktyLiter[ 'c' ] = 2;
    punktyLiter[ 'd' ] = 2;
    punktyLiter[ 'e' ] = 1;
    punktyLiter[ 'f' ] = 4;
    punktyLiter[ 'g' ] = 3;
    punktyLiter[ 'h' ] = 3;
    punktyLiter[ 'i' ] = 1;
    punktyLiter[ 'j' ] = 3;
    punktyLiter[ 'k' ] = 2;
    punktyLiter[ 'l' ] = 2;
    punktyLiter[ 'm' ] = 2;
    punktyLiter[ 'n' ] = 1;
    punktyLiter[ 'o' ] = 1;
    punktyLiter[ 'p' ] = 2;
    punktyLiter[ 'r' ] = 1;
    punktyLiter[ 's' ] = 1;
    punktyLiter[ 't' ] = 2;
    punktyLiter[ 'u' ] = 3;
    punktyLiter[ 'w' ] = 1;
    punktyLiter[ 'y' ] = 2;
    punktyLiter[ 'z' ] = 1;
    punktyLiter[ (unsigned char)'' ] = 5;
    punktyLiter[ (unsigned char)'' ] = 6;
    punktyLiter[ (unsigned char)'' ] = 5;
    punktyLiter[ (unsigned char)'' ] = 5;
    punktyLiter[ (unsigned char)'' ] = 5;
    punktyLiter[ (unsigned char)'' ] = 7;
    punktyLiter[ (unsigned char)'' ] = 7;
    punktyLiter[ (unsigned char)'' ] = 3;
    punktyLiter[ (unsigned char)'' ] = 5;
    punktyLiter[ BLANK ] = 0;

    litery_alfabetu[0] = 'a';
    litery_alfabetu[1] = '';
    litery_alfabetu[2] = 'b';
    litery_alfabetu[3] = 'c';
    litery_alfabetu[4] = '';
    litery_alfabetu[5] = 'd';
    litery_alfabetu[6] = 'e';
    litery_alfabetu[7] = '';
    litery_alfabetu[8] = 'f';
    litery_alfabetu[9] = 'g';
    litery_alfabetu[10] = 'h';
    litery_alfabetu[11] = 'i';
    litery_alfabetu[12] = 'j';
    litery_alfabetu[13] = 'k';
    litery_alfabetu[14] = 'l';
    litery_alfabetu[15] = '';
    litery_alfabetu[16] = 'm';
    litery_alfabetu[17] = 'n';
    litery_alfabetu[18] = '';
    litery_alfabetu[19] = 'o';
    litery_alfabetu[20] = '';
    litery_alfabetu[21] = 'p';
    litery_alfabetu[22] = 'r';
    litery_alfabetu[23] = 's';
    litery_alfabetu[24] = '';
    litery_alfabetu[25] = 't';
    litery_alfabetu[26] = 'u';
    litery_alfabetu[27] = 'w';
    litery_alfabetu[28] = 'y';
    litery_alfabetu[29] = 'z';
    litery_alfabetu[30] = '';
    litery_alfabetu[31] = '';
    litery_alfabetu[32] = BLANK;

    inicjujLitery();
}

/*
 * Tej funkcji uzywaja stojak i plansza, tak wiec trzeba uzaleznic od czy_polskie
 */
char Alfabet::duzaLitera( char c )
{
    if( c >= 'a' && c <= 'z' )
	return c - 32;

    if( nie_ma_polskich )
	switch( c )
	{
	    /*
	     * Trzeba tak, aby wyswietlaly sie blanki zastapione na polska litere
	     */
	    case '':
	    case '': return 'A';

	    case '':
	    case '': return 'E';

	    case '':
	    case '': return 'O';

	    case '':
	    case '': return 'S';

	    case '':
	    case '': return 'C';

	    case '':
	    case '': return 'L';

	    case '':
	    case '': return 'Z';

	    case '':
	    case '': return 'Z';

	    case '':
	    case '': return 'N';

	    case BLANK: return ' ';
	    default : return c;
	}
    else
	switch( c )
	{
	    case '': return '';
	    case '': return '';
	    case '': return '';
	    case '': return '';
	    case '': return '';
	    case '': return '';
	    case '': return '';
	    case '': return '';
	    case '': return '';
	    case BLANK: return ' ';
	    default : return c;
	}
}

/*
 * Ta funkcja uzywana jest przez modul wyszukiwania najlepszych slow, tak wiec
 * musi byc niewraziwa na czy_polskie
*/
char Alfabet::wielkaLitera( char c )
{
    if( c >= 'a' && c <= 'z' )
	return c - 32;

    switch( c )
    {
	case '': return '';
	case '': return '';
	case '': return '';
	case '': return '';
	case '': return '';
	case '': return '';
	case '': return '';
	case '': return '';
	case '': return '';
	default : return c;
    }
}

char Alfabet::malaLitera( char c )
{
    if( c >= 'A' && c <= 'Z' )
	return c + 32;

    switch( c )
    {
	case '': return '';
	case '': return '';
	case '': return '';
	case '': return '';
	case '': return '';
	case '': return '';
	case '': return '';
	case '': return '';
	case '': return '';

	default : return c;
    }
}

void Alfabet::inicjujLitery()
{
    for( int i=0; i<256; i++ )

    litery[ 'a' ] = 8;
    litery[ 'b' ] = 2;
    litery[ 'c' ] = 3;
    litery[ 'd' ] = 3;
    litery[ 'e' ] = 7;
    litery[ 'f' ] = 2;
    litery[ 'g' ] = 2;
    litery[ 'h' ] = 2;
    litery[ 'i' ] = 8;
    litery[ 'j' ] = 2;
    litery[ 'k' ] = 3;
    litery[ 'l' ] = 3;
    litery[ 'm' ] = 3;
    litery[ 'n' ] = 5;
    litery[ 'o' ] = 6;
    litery[ 'p' ] = 3;
    litery[ 'r' ] = 4;
    litery[ 's' ] = 4;
    litery[ 't' ] = 3;
    litery[ 'u' ] = 2;
    litery[ 'w' ] = 4;
    litery[ 'y' ] = 4;
    litery[ 'z' ] = 5;
    litery[ (unsigned char)'' ] = 1;
    litery[ (unsigned char)'' ] = 1;
    litery[ (unsigned char)'' ] = 1;
    litery[ (unsigned char)'' ] = 1;
    litery[ (unsigned char)'' ] = 1;
    litery[ (unsigned char)'' ] = 1;
    litery[ (unsigned char)'' ] = 1;
    litery[ (unsigned char)'' ] = 2;
    litery[ (unsigned char)'' ] = 1;
    litery[ BLANK ] = 2;

    pozostalo_liter = 0;
    for( int i=0; i<256; i++ )
	pozostalo_liter += litery[i];
}

int Alfabet::czyDuzaLitera( char c )
{
    if( c >= 'A' && c <= 'Z' )
	return 1;

    switch( c )
    {
	case '':
	case '':
	case '':
	case '':
	case '':
	case '':
	case '':
	case '':
	case '':
	    return 1;

	default:
	    return 0;
    }
}

char Alfabet::doogonkuj( char c )
{
    switch( c )
    {
	case '':
	case '': return '`';
	case '':
	case '': return '`';
	case '':
	case '': return 0x27; // tzn. znaczek '
	case '':
	case '': return 0x27;
	case '':
	case '': return 0x27;
	case '':
	case '': return '/';
	case '':
	case '': return '.';
	case '':
	case '': return 0x27;
	case '':
	case '': return 0x27;
	default : return 0;
    }
}

int Alfabet::gdzieHOgonek( char c )
{
    switch( c )
    {
	case '':
	case '': return 16;
	case '':
	case '': return 16;
	case '':
	case '': return 14;
	case '':
	case '': return 14;
	case '':
	case '': return 14;
	case '':
	case '': return 13;
	case '':
	case '': return 12;
	case '':
	case '': return 13;
	case '':
	case '': return 14;
	default : return 0;
    }
}

int Alfabet::gdzieVOgonek( char c )
{
    switch( c )
    {
	case '':
	case '': return 34;
	case '':
	case '': return 34;
	case '':
	case '': return 16;
	case '':
	case '': return 16;
	case '':
	case '': return 16;
	case '':
	case '': return 22;
	case '':
	case '': return 8;
	case '':
	case '': return 16;
	case '':
	case '': return 16;
	default : return c;
    }
}

int Alfabet::potrzebnyOgonek( char c )
{
    if( ( c >= 'a' && c <= 'z' ) || ( c >= 'A' && c <= 'Z' ) )
	return false;
    else
	return true;
}

