#include "blanka.h"
#include "alfabet.h"
#include "qpainter.h"
#include "qwindefs.h"

ZastapBlanka::ZastapBlanka( QWidget *parent , const char *name ) : QSemiModal( parent , name , true , WStyle_DialogBorder )
{
    alfabet = NULL;

    setMinimumSize( 240 , 120 );
    setMaximumSize( 240 , 120 );

    setCaption( "Zastp blanka" );
}

void ZastapBlanka::paintEvent( QPaintEvent * )
{
    QPainter paint;
    QString s;

    paint.begin( this );

    paint.setPen( black );
    paint.setBrush( darkGray );
    paint.setFont( QFont( "Times" , 18 , QFont::Bold ) );

    for( int j=0; j<4; j++ )
	for( int i=0; i<8; i++ )
	{
	    paint.drawRect( i*30 + 1 , j*30 + 1 , 28 , 28 );

	    s.sprintf( "%c" , alfabet->duzaLitera( alfabet->literaAlfabetu( j*8 + i + 1 ) ) );
	    paint.drawText( i*30 + 1 , j*30 + 1 , 28 , 28 , AlignCenter , s , 1 );

	    if( alfabet->nieMaPolskich() && alfabet->potrzebnyOgonek( alfabet->literaAlfabetu( j*8 + i + 1 ) ) );
	    {
		s = tr( "%1" ).arg( alfabet->doogonkuj( alfabet->literaAlfabetu( j*8 + i + 1 ) ) );

		int vert_offset = alfabet->gdzieVOgonek( alfabet->literaAlfabetu( j*8 + i + 1 ) );
		int hor_offset  = alfabet->gdzieHOgonek( alfabet->literaAlfabetu( j*8 + i + 1 ) );

		paint.drawText( i*30 + hor_offset , j*30 + vert_offset , s , 1 );
	    }
	}

    paint.end();
}

void ZastapBlanka::mousePressEvent( QMouseEvent *e )
{
    if ( e->button() != LeftButton )
	return;

    hide();

    emit kliknietyZastapBlanka( alfabet->literaAlfabetu( e->x()/30 + 1 + (e->y()/30)*8 ) );
}
