#include <qlabel.h>
#include <qframe.h>
#include <qwindefs.h>
#include <stdio.h>

#include "dupa.h"
#include "litery.h"

Litery::Litery( QWidget *parent , const char *name ) : QWidget( parent , name )
{
    setMaximumSize( 20 , 20 );

    pokazIleLiter = new QLabel( this , "pokaz" );
    pokazIleLiter->setGeometry( 0 , 0 , 20 , 20 );
    pokazIleLiter->setFrameStyle( QFrame::Sunken | QFrame::Panel );
    pokazIleLiter->setAlignment( AlignCenter );

    ile_liter = 7;
    litery = new char[7];

    kasujLitery();

    pokazIleLiter->setNum( ileLiter() );
}

Litery::Litery( int  ile , QWidget *parent , const char *name ) : QWidget( parent , name )
{
    pokazIleLiter = new QLabel( this , "pokaz" );
    pokazIleLiter->setGeometry( 0 , 0 , 10 , 10 );
    pokazIleLiter->setFrameStyle( QFrame::Sunken | QFrame::Panel );
    pokazIleLiter->setAlignment( AlignTop | AlignHCenter );

    ile_liter = ile;

    if( ile_liter <= 0 )
	ile_liter = 7;

    litery = new char[ile_liter];

    kasujLitery();

    pokazIleLiter->setNum( ileLiter() );
}

Litery::~Litery()
{
    if( ile_liter > 0 )
	delete litery;
}

void Litery::kasujLitery()
{
    for( int i=0; i<ile_liter; i++ )
	litery[i] = PUSTE_POLE;

    pokazIleLiter->setNum( ileLiter() );
}

void Litery::zmienLitere( char l , int gdzie )
{
    litery[gdzie] = l;

    pokazIleLiter->setNum( ileLiter() );
}

void Litery::kasujLitere( int gdzie )
{
    litery[gdzie] = PUSTE_POLE;

    pokazIleLiter->setNum( ileLiter() );
}

void Litery::zmienLitery( char *wzor , int ile )
{
    for( int i=0; i<ile; i++ )
	litery[i] = wzor[i];

    pokazIleLiter->setNum( ileLiter() );
}

void Litery::kasujLitere( char l )
{
    for( int i=0; i<ile_liter; i++ )
	if( litery[i] == l )
	{
	    litery[i] = PUSTE_POLE;
	    break;
	}

    pokazIleLiter->setNum( ileLiter() );
}

int Litery::ileLiter()
{
    int ile = 0;

    for( int i=0; i<ile_liter; i++ )
	if( litery[i] != PUSTE_POLE )
	    ile++;

    return ile;
}

void Litery::uaktualnijNaRysunku()
{
    pokazIleLiter->setNum( ileLiter() );
}

void Litery::pustePolaNaKoniec()
{
    for( int i=ile_liter-1; i>=0; i-- )
	if( litery[i] == PUSTE_POLE )
	    for( int j=i; j<ile_liter-1; j++ )
	    {
		litery[j] = litery[j+1];
		litery[j+1] = PUSTE_POLE;
	    }
}

int Litery::ileDanejLitery( char c )
{
    int wyn = 0;

    for( int i=0; i<ile_liter; i++ )
	if( litery[i] == c )
	    wyn++;

    return wyn;
}
