#include <stdlib.h>
#include <stdio.h>

#include "qwindefs.h"
#include "qpushbt.h"
#include "qlistbox.h"

#include "ograczach.h"

OGraczach::OGraczach( QWidget *parent , const char *name ) : QSemiModal( parent , name , true , WStyle_DialogBorder )
{
    setCaption( "O graczach" );

    setMinimumSize( 300 , 250 );
    setMaximumSize( 300 , 250 );

    tabela = new QListBox( this , "tabelka" );
    tabela->setGeometry( 10 , 10 , 280 , 200 );

    zamknijButton = new QPushButton( "&Zamknij" , this , "zamknij_button" );
    zamknijButton->setGeometry( 120 , 220 , 60 , 20 );

    gracze = NULL;

    connect( zamknijButton , SIGNAL( clicked() ) , SLOT( hide() ) );
}

void OGraczach::show()
{
    QString s;

    if( gracze == NULL )
	return;

    tabela->clear();

    for( int i=0; i<gracze->iluGraczy(); i++ )
    {
	s = tr( "%1: %2, ranking: %3" ).
	    arg( (*gracze)[i].dajImie() ).
	    arg( ((*gracze)[i].graczZKrwi()) ? "Gracz z krwi i koci" : "Gracz wirtualny" ).
	    arg( (*gracze)[i].ranking() );

	tabela->insertItem( s );
    }

    QSemiModal::show();
}
