//#include <qapp.h>
#include <stdio.h>

#include <qpainter.h>
#include <qwindefs.h>
#include <qfont.h>

#include "plansza.h"
#include "dupa.h"
#include "alfabet.h"

Plansza::Plansza( QWidget *parent , const char *name ) : QWidget( parent, name )
{
    int i, j;

    for( i=0; i<15; i++ )
	for( j=0; j<15; j++ )
	{
	    pola[i][j].litera = PUSTE_POLE;
	    pola[i][j].premia = NORMAL;
	    pola[i][j].dolozona = 0;
	}

    pola[1][1].premia = DWAS;
    pola[2][2].premia = DWAS;
    pola[3][3].premia = DWAS;
    pola[4][4].premia = DWAS;
    pola[7][7].premia = DWAS;
    pola[10][10].premia = DWAS;
    pola[11][11].premia = DWAS;
    pola[12][12].premia = DWAS;
    pola[13][13].premia = DWAS;
    pola[1][13].premia = DWAS;
    pola[2][12].premia = DWAS;
    pola[3][11].premia = DWAS;
    pola[4][10].premia = DWAS;
    pola[10][4].premia = DWAS;
    pola[11][3].premia = DWAS;
    pola[12][2].premia = DWAS;
    pola[13][1].premia = DWAS;
    pola[3][0].premia = DWAL;
    pola[11][0].premia = DWAL;
    pola[6][2].premia = DWAL;
    pola[8][2].premia = DWAL;
    pola[7][3].premia = DWAL;
    pola[0][3].premia = DWAL;
    pola[14][3].premia = DWAL;
    pola[2][6].premia = DWAL;
    pola[6][6].premia = DWAL;
    pola[8][6].premia = DWAL;
    pola[12][6].premia = DWAL;
    pola[3][7].premia = DWAL;
    pola[11][7].premia = DWAL;
    pola[2][8].premia = DWAL;
    pola[6][8].premia = DWAL;
    pola[8][8].premia = DWAL;
    pola[12][8].premia = DWAL;
    pola[0][11].premia = DWAL;
    pola[7][11].premia = DWAL;
    pola[14][11].premia = DWAL;
    pola[6][12].premia = DWAL;
    pola[8][12].premia = DWAL;
    pola[3][14].premia = DWAL;
    pola[11][14].premia = DWAL;
    pola[5][1].premia = TRZYL;
    pola[9][1].premia = TRZYL;
    pola[1][5].premia = TRZYL;
    pola[5][5].premia = TRZYL;
    pola[9][5].premia = TRZYL;
    pola[13][5].premia = TRZYL;
    pola[1][9].premia = TRZYL;
    pola[5][9].premia = TRZYL;
    pola[9][9].premia = TRZYL;
    pola[13][9].premia = TRZYL;
    pola[5][13].premia = TRZYL;
    pola[9][13].premia = TRZYL;
    pola[0][0].premia = TRZYS;
    pola[7][0].premia = TRZYS;
    pola[14][0].premia = TRZYS;
    pola[0][7].premia = TRZYS;
    pola[14][7].premia = TRZYS;
    pola[0][14].premia = TRZYS;
    pola[7][14].premia = TRZYS;
    pola[14][14].premia = TRZYS;

    podswx = podswy = -1;
}

const QRect planszaRect( 0 , 0 , 450 , 450 );

void Plansza::paintEvent( QPaintEvent *e )
{
    QPainter paint;
    QString s;
    QRect updateR = e->rect();

    paint.begin( this );

    paint.setPen( black );

    for( int i=0; i<15; i++ )
	for( int j=0; j<15; j++ )
	{
	    if(	!updateR.intersects( QRect( i*30+1 , j*30+1 , 28 , 28 ) ) )
		continue;

	    if( pola[i][j].litera == PUSTE_POLE )
		switch( pola[i][j].premia )
		{
		    case DWAL:
			paint.setBrush( blue );
			break;
		    case TRZYL:
			paint.setBrush( darkBlue );
			break;
		    case DWAS:
			paint.setBrush( red );
			break;
		    case TRZYS:
			paint.setBrush( darkRed );
			break;
		    default:
			paint.setBrush( darkGreen );
			break;
		}
	    else
	    {
		if( podswx == i && podswy == j )
		    paint.setBrush( yellow );
		else
		{
		    if( pola[i][j].dolozona )
			paint.setBrush( lightGray );
		    else
			paint.setBrush( darkGray );
		}
	    }

	    paint.drawRect( i*30 + 1 , j*30 + 1 , 28 , 28 );

	    if( pola[i][j].litera != PUSTE_POLE )
	    {
		s.sprintf( "%c" , alfabet->duzaLitera( pola[i][j].litera ) );
		paint.setFont( QFont( "Times" , 18 , QFont::Bold ) );
		paint.drawText( i*30 + 1 , j*30 + 1 , 26 , 26 , AlignCenter , s , 1 );

		if( alfabet->nieMaPolskich() && alfabet->potrzebnyOgonek( pola[i][j].litera ) )
		{
		    s = tr( "%1" ).arg( alfabet->doogonkuj( pola[i][j].litera ) );

		    int vert_offset = alfabet->gdzieVOgonek( pola[i][j].litera );
		    int hor_offset  = alfabet->gdzieHOgonek( pola[i][j].litera );

		    paint.drawText( i*30 - 1 + hor_offset , j*30 - 1 + vert_offset , s , 1 );
		}

		if( alfabet->dajPunktyLitery( pola[i][j].litera ) > 0 )
		{
		    s.sprintf( "%i" , alfabet->dajPunktyLitery( pola[i][j].litera ) );
		    paint.setFont( QFont( "Times" , 10 , QFont::Bold ) );
		    paint.drawText( i*30 + 19 , j*30 + 16 , 10 , 10 , AlignCenter , s , 1 );
		}
	    }
	    else
	    {
		if( pola[i][j].premia != NORMAL )
		{
		    paint.setFont( QFont( "Arial" , 10 , QFont::Bold ) );
		    switch( pola[i][j].premia )
		    {
			case DWAL:
			    s.sprintf( "2L" );
			    paint.drawText( i*30+1 , j*30+1 , 28 , 28 , AlignCenter , s , 2 );
			    break;
			case TRZYL:
			    s.sprintf( "3L" );
			    paint.drawText( i*30+1 , j*30+1 , 28 , 28 , AlignCenter , s , 2 );
			    break;
			case DWAS:
			    s.sprintf( "2S" );
			    paint.drawText( i*30+1 , j*30+1 , 28 , 28 , AlignCenter , s , 2 );
			    break;
			case TRZYS:
			    s.sprintf( "3S" );
			    paint.drawText( i*30+1 , j*30+1 , 28 , 28 , AlignCenter , s , 2 );
			    break;
			default:;
		    }
		}
	    }
	}

    paint.end();
}

void Plansza::mousePressEvent( QMouseEvent *e )
{
    if ( e->button() != LeftButton )
	return;

    emit kliknietaPlansze( e->x() / 30 , e->y() / 30 );
}

/*
 * Tu rzeczy nie zwiazane z rysowaniem
 */
 
int Plansza::premia( int i , int j )
{
    return pola[i][j].premia;
}

char Plansza::litera( int i , int j )
{
    return pola[i][j].litera;
}

void Plansza::ustawLitere( char l , int i , int j )
{
    if( pola[i][j].litera == l )
	return;

    pola[i][j].litera = l;
    repaint( QRect( i*30+1 , j*30+1 , 28 , 28 ) );
}

void Plansza::ustawPremie( int p , int i , int j )
{
    pola[i][j].premia = p;
}

int Plansza::poprawnieDolozoneSlowo()
{
    int pierx = -1, piery = -1;
    int byla_zwykla = 0;
    int dolozonych = 0, zlicz_w_linii = 0;
    int horyzont;

    for( int i=0; i<15; i++ )
	for( int j=0; j<15; j++ )
	    if( pola[i][j].dolozona )
	    {
		if( pierx == -1 )
		{
		    pierx = i;
		    piery = j;
		}

		dolozonych++;
	    }

    horyzont = PIONOWO;

    for( int i=pierx+1; i<15; i++ )
    {
	if( pola[i][piery].dolozona )
	    horyzont = POZIOMO;
    }

    while( pierx < 15 && piery < 15 )
    {
	if( pola[pierx][piery].litera == PUSTE_POLE )
	    break;

	if( pierx > 0 )
	    if( !pola[pierx-1][piery].dolozona && pola[pierx-1][piery].litera != PUSTE_POLE )
		byla_zwykla = 1;
	
	if( piery > 0 )
	    if( !pola[pierx][piery-1].dolozona && pola[pierx][piery-1].litera != PUSTE_POLE )
		byla_zwykla = 1;
	
	if( pierx < 14 )
	    if( !pola[pierx+1][piery].dolozona && pola[pierx+1][piery].litera != PUSTE_POLE )
		byla_zwykla = 1;
	
	if( piery < 14 )
	    if( !pola[pierx][piery+1].dolozona && pola[pierx][piery+1].litera != PUSTE_POLE )
		byla_zwykla = 1;
	
	if( pola[pierx][piery].dolozona )
	    zlicz_w_linii++;

	if( horyzont == POZIOMO )
	    pierx++;
	else
	    piery++;
    }

    if( zlicz_w_linii == dolozonych )
    {
	if( byla_zwykla )
	    return 1;
	else
	    if( pola[7][7].dolozona )
		return 1;
    }

    return 0;
}

void Plansza::podswietlLitereUstawionaPrzezKomputer( char l , int i , int j )
{
    pola[i][j].litera = l;
    pola[i][j].dolozona = 1;

    repaint( QRect( i*30+1 , j*30+1 , 28 , 28 ) );
}

void Plansza::ustawDolozonaLitere( char l , int i , int j )
{
    pola[i][j].litera = l;
    pola[i][j].dolozona = 1;

    repaint( QRect( i*30+1 , j*30+1 , 28 , 28 ) );

    if( poprawnieDolozoneSlowo() )
	emit moznaOkKlikac( true );
    else
	emit moznaOkKlikac( false );
}

void Plansza::zdejmijDolozonaLitere( int i , int j )
{
    if( !pola[i][j].dolozona )
	return;

    pola[i][j].litera = PUSTE_POLE;
    pola[i][j].dolozona = 0;

    repaint( QRect( i*30+1 , j*30+1 , 28 , 28 ) );

    if( poprawnieDolozoneSlowo() )
	emit moznaOkKlikac( true );
    else
	emit moznaOkKlikac( false );
}

void Plansza::zdejmijDolozoneLitery()
{
    for( int i=0; i<15; i++ )
	for( int j=0; j<15; j++ )
	    if( pola[i][j].dolozona )
		zdejmijDolozonaLitere( i , j );
}

void Plansza::podswietlLitere( int i , int j )
{
    if( pola[i][j].litera == PUSTE_POLE )
	return;

    if( i == podswx && j == podswy )
	return;

    if( !pola[i][j].dolozona )
	return;

    podswx = i;
    podswy = j;

    repaint( QRect( i*30+1 , j*30+1 , 28 , 28 ) );
}

void Plansza::zgasLitere()
{
    int i, j;

    i = podswx;
    j = podswy;

    podswx = -1;
    podswy = -1;

    repaint( QRect( i*30+1 , j*30+1 , 28 , 28 ) );
}

int Plansza::saLiteryDolozone()
{
    for( int i=0; i<15; i++ )
	for( int j=0; j<15; j++ )
	    if( pola[i][j].dolozona )
		return 1;

    return 0;
}

int Plansza::saLitery()
{
    for( int i=0; i<15; i++ )
	for( int j=0; j<15; j++ )
	    if( pola[i][j].litera != PUSTE_POLE )
		return 1;

    return 0;
}

int Plansza::ilePunktow( int i , int j , int horyzont )
{
    int punkty = 0;
    int ile_dolozonych = 0;
    int mnoznik_slowa = 1;

    while( i<15 && j<15 )
    {
	if( pola[i][j].litera == PUSTE_POLE )
	    break;

	if( !pola[i][j].dolozona )
	    punkty += alfabet->dajPunktyLitery( pola[i][j].litera );
	else
	{
	    ile_dolozonych++;

	    switch( pola[i][j].premia )
	    {
		case DWAL:
		    punkty += 2 * alfabet->dajPunktyLitery( pola[i][j].litera );
		    break;

		case TRZYL:
		    punkty += 3 * alfabet->dajPunktyLitery( pola[i][j].litera );
		    break;

		case DWAS:
		    punkty += alfabet->dajPunktyLitery( pola[i][j].litera );
		    mnoznik_slowa *= 2;
		    break;

		case TRZYS:
		    punkty += alfabet->dajPunktyLitery( pola[i][j].litera );
		    mnoznik_slowa *= 3;
		    break;

		default:
		    punkty += alfabet->dajPunktyLitery( pola[i][j].litera );
		    break;
	    }
	}

	if( horyzont == POZIOMO )
	    i++;
	else
	    j++;
    }

    punkty *= mnoznik_slowa;

    if( ile_dolozonych == 7 )
	punkty += 50;

    return punkty;
}

int Plansza::ilePunktow()
{
    int pierwx = -1, pierwy = -1, do_gory = 0, w_lewo = 0;
    int horyzont = POZIOMO;
    int pkt = 0, dolozona_druga = 0;

    if( poprawnieDolozoneSlowo() )
    {
	for( int i=0; i<15; i++ )
	    for( int j=0; j<15; j++ )
		if( pola[i][j].dolozona )
		{
		    if( pierwx == -1 )
		    {
			pierwx = i;
			pierwy = j;
		    }
		    break;
		}

	for( int i=pierwx+1; i<15; i++ )
	    if( literaDolozona( i , pierwy ) )
	    {
		horyzont = POZIOMO;
		dolozona_druga = 1;
		break;
	    }

	if( !dolozona_druga )
	    for( int j=pierwy+1; j<15; j++ )
		if( literaDolozona( pierwx , j ) )
		{
		    horyzont = PIONOWO;
		    dolozona_druga = 1;
		    break;
		}

	if( !dolozona_druga )
	{
	    if( pierwx > 0 && litera( pierwx - 1 , pierwy ) != PUSTE_POLE )
		horyzont = POZIOMO;

	    if( pierwx < 14 && litera( pierwx + 1 , pierwy ) != PUSTE_POLE )
		horyzont = POZIOMO;

	    if( pierwy > 0 && litera( pierwx , pierwy - 1 ) != PUSTE_POLE )
		horyzont = PIONOWO;

	    if( pierwy < 14 && litera( pierwx , pierwy + 1 ) != PUSTE_POLE )
		horyzont = PIONOWO;
	}

	if( horyzont == POZIOMO )
	    while( pierwx > 0 && pola[pierwx-1][pierwy].litera != PUSTE_POLE )
		pierwx--;
	else
	    while( pierwy > 0 && pola[pierwx][pierwy-1].litera != PUSTE_POLE )
		pierwy--;

	pkt += ilePunktow( pierwx , pierwy , horyzont );

	while( pierwx < 15 && pierwy < 15 )
	{
	    if( pola[ pierwx ][ pierwy ].litera == PUSTE_POLE )
		break;

	    if( literaDolozona( pierwx , pierwy ) )
	    {
		if( horyzont == POZIOMO )
		{
		    do_gory = 0;
		    while( pierwy-do_gory-1 >= 0 )
			if( litera( pierwx , pierwy-do_gory-1 ) != PUSTE_POLE )
			    do_gory++;
			else
			    break;

		    if( do_gory > 0 || ( pierwy < 14 && litera( pierwx , pierwy + 1 ) != PUSTE_POLE ) )
			pkt += ilePunktow( pierwx , pierwy-do_gory , PIONOWO );
		}
		else
		{
		    w_lewo = 0;
		    while( pierwx-w_lewo-1 >= 0 )
			if( litera( pierwx-w_lewo-1 , pierwy ) != PUSTE_POLE )
			    w_lewo++;
			else
			    break;

		    if( w_lewo > 0 || ( pierwx < 14 && litera( pierwx + 1 , pierwy ) != PUSTE_POLE ) )
			pkt += ilePunktow( pierwx-w_lewo , pierwy , POZIOMO );
		}
	    }

	    if( horyzont == POZIOMO )
		pierwx++;
	    else
		pierwy++;
	}
    }

    return pkt;
}

void Plansza::zdejmijDolozenieZDolozonychLiter()
{
    for( int i=0; i<15; i++ )
	for( int j=0; j<15; j++ )
	    if( pola[i][j].dolozona )
	    {
		pola[i][j].dolozona = 0;
	        repaint( QRect( i*30+1 , j*30+1 , 28 , 28 ) );
	    }	
}

void Plansza::czyscPlansze()
{
    for( int i=0; i<15; i++ )
	for( int j=0; j<15; j++ )
	{
	    pola[i][j].litera = PUSTE_POLE;
	    pola[i][j].dolozona = 0;
	}

    repaint( QRect( 0 , 0 , 450 , 450 ) );
}

int Plansza::polozonyBlank()
{
    for( int i=0; i<15; i++ )
	for( int j=0; j<15; j++ )
	    if( pola[i][j].litera == BLANK )
		return 1;

    return 0;
}

void Plansza::zastapBlanka( char na_co )
{
    for( int i=0; i<15; i++ )
	for( int j=0; j<15; j++ )
	    if( pola[i][j].litera == BLANK )
	    {
		pola[i][j].litera = alfabet->wielkaLitera( na_co );
	        repaint( QRect( i*30+1 , j*30+1 , 28 , 28 ) );
		return;
	    }

}

void Plansza::zapalBlanka()
{
    for( int i=0; i<15; i++ )
	for( int j=0; j<15; j++ )
	    if( pola[i][j].litera == BLANK )
	    {
		podswietlLitere( i , j );
		return;
	    }

}

void Plansza::zgasBlanka()
{
    zgasLitere();
}
