#include "podswietlenie.h"
#include "stojak.h"
#include "plansza.h"
#include "dupa.h"

Podswietlenie::Podswietlenie( QWidget *parent = 0 , const char *name = 0 ) : QWidget( parent , name )
{
    gdzie = NIGDZIE;
    stojak = NULL;
    plansza = NULL;
}

void Podswietlenie::kliknietoStojak( int nr )
{
    char l;

    switch( gdzie )
    {
	case NIGDZIE:
	    if( stojak->literaNaStojaku( nr ) != PUSTE_POLE )
	    {
		gdzie = STOJAK;
		x = nr;
		stojak->podswietlLitereNaStojaku( nr );
	    }
	    else
	    {
		for( int i=0; i<15; i++ )
		    for( int j=0; j<15; j++ )
			if( plansza->literaDolozona( i , j ) )
			    for( int k=0; k<7; k++ )
			    {
				if( stojak->literaNaStojaku( k ) != PUSTE_POLE )
				    continue;

				stojak->ustawLitereNaStojaku( plansza->litera( i , j ) , k );
				break;
			    }

		plansza->zdejmijDolozoneLitery();
	    }

	    break;

	case STOJAK:
	    gdzie = NIGDZIE;
	    stojak->zgasLitereNaStojaku();
	    stojak->zamienLiteryNaStojaku( x , nr );

	    break;

	case DO_WYMIANY:
	    gdzie = NIGDZIE;
	    stojak->zgasLitereDoWymiany();
	    l = stojak->literaDoWymiany( x );

	    if( stojak->literaNaStojaku( nr ) == PUSTE_POLE )
		stojak->ustawLitereDoWymiany( PUSTE_POLE , x );
	    else
		stojak->ustawLitereDoWymiany( stojak->literaNaStojaku( nr ) , x );

	    stojak->ustawLitereNaStojaku( l , nr );

	    break;

	case PLANSZA:
	    gdzie = NIGDZIE;
	    plansza->zgasLitere();
	    l = plansza->litera( x , y );

	    if( stojak->literaNaStojaku( nr ) == PUSTE_POLE )
		plansza->zdejmijDolozonaLitere( x , y );
	    else
		plansza->ustawDolozonaLitere( stojak->literaNaStojaku( nr ) , x , y );

	    stojak->ustawLitereNaStojaku( l , nr );

	    break;

	default:;
    }
}

void Podswietlenie::kliknietoDoWymiany( int nr )
{
    char l;

    switch( gdzie )
    {
	case NIGDZIE:
	    if( stojak->literaDoWymiany( nr ) != PUSTE_POLE )
	    {
		gdzie = DO_WYMIANY;
		x = nr;
		stojak->podswietlLitereDoWymiany( nr );
	    }
	    break;

	case DO_WYMIANY:
	    gdzie = NIGDZIE;
	    stojak->zgasLitereDoWymiany();
	    stojak->zamienLiteryDoWymiany( x , nr );

	    break;

	case STOJAK:
	    gdzie = NIGDZIE;
	    stojak->zgasLitereNaStojaku();
	    l = stojak->literaNaStojaku( x );

	    if( stojak->literaDoWymiany( nr ) == PUSTE_POLE )
		stojak->ustawLitereNaStojaku( PUSTE_POLE , x );
	    else
		stojak->ustawLitereNaStojaku( stojak->literaDoWymiany( nr ) , x );

	    stojak->ustawLitereDoWymiany( l , nr );

	    break;
		
	case PLANSZA:
	    gdzie = NIGDZIE;
	    plansza->zgasLitere();
	    l = plansza->litera( x , y );

	    if( stojak->literaDoWymiany( nr ) == PUSTE_POLE )
		plansza->zdejmijDolozonaLitere( x , y );
	    else
		plansza->ustawDolozonaLitere( stojak->literaDoWymiany( nr ) , x , y );

	    stojak->ustawLitereDoWymiany( l , nr );

	    break;

	default:;
    }
}

void Podswietlenie::kliknietoPlansze( int nrx , int nry )
{
    char l;

    switch( gdzie )
    {
	case NIGDZIE:
	    if( plansza->literaDolozona( nrx , nry ) && stojak->isEnabled() )
	    {
		gdzie = PLANSZA;
		x = nrx;
		y = nry;
		plansza->podswietlLitere( x , y );
	    }
	    else
		if( plansza->litera( nrx , nry ) == PUSTE_POLE && stojak->saLiteryNaStojaku() && stojak->isEnabled() )
		{
		    for( int i=0; i<7; i++ )
		    {
			if( ( l = stojak->literaNaStojaku( i ) ) == PUSTE_POLE )
			    continue;

			stojak->ustawLitereNaStojaku( PUSTE_POLE , i );
			plansza->ustawDolozonaLitere( l , nrx , nry );
			break;
		    }
		}
	break;

	case STOJAK:
	    if( plansza->litera( nrx , nry ) == PUSTE_POLE )
	    {
		gdzie = NIGDZIE;
		stojak->zgasLitereNaStojaku();
		l = stojak->literaNaStojaku( x );
		stojak->ustawLitereNaStojaku( PUSTE_POLE , x );
		plansza->ustawDolozonaLitere( l , nrx , nry );
	    }
	    else
		if( plansza->literaDolozona( nrx , nry ) )
		{
		    gdzie = NIGDZIE;
		    stojak->zgasLitereNaStojaku();
		    l = stojak->literaNaStojaku( x );
		    stojak->ustawLitereNaStojaku( plansza->litera( nrx , nry ) , x );
		    plansza->ustawDolozonaLitere( l , nrx , nry );
		}
	    break;
		    
	case DO_WYMIANY:
	    if( plansza->litera( nrx , nry ) == PUSTE_POLE )
	    {
		gdzie = NIGDZIE;
		stojak->zgasLitereDoWymiany();
		l = stojak->literaDoWymiany( x );
		stojak->ustawLitereDoWymiany( PUSTE_POLE , x );
		plansza->ustawDolozonaLitere( l , nrx , nry );
	    }
	    else
		if( plansza->literaDolozona( nrx , nry ) )
		{
		    gdzie = NIGDZIE;
		    stojak->zgasLitereDoWymiany();
		    l = stojak->literaDoWymiany( x );
		    stojak->ustawLitereDoWymiany( plansza->litera( nrx , nry ) , x );
		    plansza->ustawDolozonaLitere( l , nrx , nry );
		}
	    break;

	case PLANSZA:
	    if( plansza->litera( nrx , nry ) == PUSTE_POLE )
	    {
		gdzie = NIGDZIE;
		plansza->zgasLitere();
		l = plansza->litera( x , y );
		plansza->zdejmijDolozonaLitere( x , y );
		plansza->ustawDolozonaLitere( l , nrx , nry );
	    }
	    else
		if( plansza->literaDolozona( nrx , nry ) )
		{
		    gdzie = NIGDZIE;
		    plansza->zgasLitere();
		    l = plansza->litera( x , y );
		    plansza->zdejmijDolozonaLitere( x , y );
		    plansza->ustawDolozonaLitere( plansza->litera( nrx , nry ) , x , y );
		    plansza->ustawDolozonaLitere( l , nrx , nry );
		}
	    break;

	default:;    
    }
}

void Podswietlenie::wylaczPodswietlenie()
{
    switch( gdzie )
    {
	case NIGDZIE:
	    break;

	case PLANSZA:
	    gdzie = NIGDZIE;
	    plansza->zgasLitere();
	    break;

	case STOJAK:
	    gdzie = NIGDZIE;
	    stojak->zgasLitereNaStojaku();
	    break;

	case DO_WYMIANY:
	    gdzie = NIGDZIE;
	    stojak->zgasLitereDoWymiany();
	    break;

	default:;
    }
}
