#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <qapp.h>
#include <qpushbt.h>
#include <qlabel.h>
#include <qcombo.h>
#include <qframe.h>
#include <qwindefs.h>
#include <qmenubar.h>
#include <qpopmenu.h>

#include "sakreble.h"
#include "plansza.h"
#include "stojak.h"
#include "dupa.h"
#include "punkty.h"
#include "litery.h"
#include "podswietlenie.h"
#include "lampka.h"
#include "blanka.h"
#include "sprawdzacz.h"
#include "zostalo.h"
#include "gracz.h"
#include "ograczach.h"

Sakreble::Sakreble( QWidget *parent , const char *name ) : QWidget( parent, name )
{
    setMinimumSize( 600 , 540 );
    setMaximumSize( 600 , 540 );

    setFont( QFont( "Arial" , 12 , QFont::Normal ) );

    setCaption( "Sakreble!" );

    quit = new QPushButton( "Koniec", this, "quit" );
    quit->setFont( QFont( "Times", 18, QFont::Bold ) );
    quit->move( 470 , 430 );

    start = new QPushButton( "Start", this, "start" );
    start->setFont( QFont( "Times", 18, QFont::Bold ) );
    start->move( 470 , 40 );

    nextGame = new QPushButton( tr( "Nastpna gra" ) , this, "nextgame" );
    nextGame->move( 470 , 40 );

    sprawdzButton = new QPushButton( "Sprawd", this, "sprawdz" );
    sprawdzButton->move( 470 , 70 );

    zatwierdzButton = new QPushButton( "Ok", this, "zatwierdz" );
    zatwierdzButton->move( 470 , 40 );

    next = new QPushButton( "Dalej", this, "dalej" );
    next->setFont( QFont( "Times", 18, QFont::Bold ) );
    next->move( 470 , 80 );
    next->hide();

    ok = new QPushButton( "Ok", this, "ok" );
    ok->setGeometry( 470 , 40 , 100 , 28 );
    ok->hide();

    wymien = new QPushButton( "Wymie", this, "wymien" );
    wymien->setGeometry( 470 , 70 , 100 , 28 );
    wymien->hide();

    pas = new QPushButton( "Pas", this, "pas" );
    pas->setGeometry( 470 , 100 , 100 , 28 );
    pas->hide();

    zostaloLiterButton = new QPushButton( "cigawka", this, "pas" );
    zostaloLiterButton->setGeometry( 470 , 400 , 100 , 20 );
    zostaloLiterButton->hide();

    label = new QLabel( "vs" , this , "label" );
    label->move( 512 , 115 );

    plansza = new Plansza( this , "plansza" );
    plansza->setGeometry( 10 , 40 , 450 , 450 );
    plansza->ustawAlfabet( &alfabet );

    stojak = new Stojak( this , "stojak" );
    stojak->setGeometry( 10 , 500 , 450 , 30 );
    stojak->ustawAlfabet( &alfabet );

    pozostaloLabel = new QLabel( this , "pozostaloLiter" );
    pozostaloLabel->setFrameStyle( QFrame::Sunken | QFrame::Panel );
    pozostaloLabel->setGeometry( 221 , 501 , 28 , 28 );
    pozostaloLabel->setAlignment( AlignCenter );

    gracze = new Gracze( NULL , "gracze" );
    gracze->zPliku();

    graczCombo[0] = new QComboBox( this , "pierwszecombo" );
    graczCombo[0]->setGeometry( 470 , 90 , 100 , 30 );

    graczCombo[1] = new QComboBox( this , "drugiecombo" );
    graczCombo[1]->setGeometry( 470 , 140 , 100 , 30 );

    imionaGraczyDoCombow();
    if( gracze->iluGraczy() > 1 )
	graczCombo[1]->setCurrentItem(1);
    zmajstrujComba();

    punkty[0] = new Punkty( this , "punk0" );
    punkty[0]->move( 470 , 200 );
    punkty[0]->hide();
    punkty[1] = new Punkty( this , "punk1" );
    punkty[1]->move( 470 , 250 );
    punkty[1]->hide();

    ten_ruch = new Punkty( this , "tenruch" );
    ten_ruch->move( 470 , 320 );
    ten_ruch->ustawImie( "Ten ruch" );
    ten_ruch->hide();

    literyGracza[0] = new Litery( this , "lit0" );
    literyGracza[0]->move( 570 , 200 );
    literyGracza[1] = new Litery( this , "lit1" );
    literyGracza[1]->move( 570 , 250 );

    podsw = new Podswietlenie;
    podsw->ustawStojak( stojak );
    podsw->ustawPlansze( plansza );

    zastapBlanka = new ZastapBlanka( NULL , "zastapblanka" );
    zastapBlanka->ustawAlfabet( &alfabet );

    zostalo = new Zostalo( NULL , "zostalo" );
    zostalo->ustawAlfabet( &alfabet );
    zostalo->ustawLiteryGracza( 0 , literyGracza[0] );
    zostalo->ustawLiteryGracza( 1 , literyGracza[1] );
    zostalo->ustawKtoryGracz( &ktoryDoSciagawki );

    lampka[0] = new Lampka( this , "lampka0" );
    lampka[0]->setGeometry( 570 , 220 , 20 , 20 );
    lampka[1] = new Lampka( this , "lampka0" );
    lampka[1]->setGeometry( 570 , 270 , 20 , 20 );

    oGraczach = new OGraczach( NULL , "o graczach" );
    oGraczach->ustawGraczy( gracze );

    menuGra = new QPopupMenu();
    idy_menu[ GRA_NOWA_GRA_ID ] = menuGra->insertItem( "&Nowa gra" , this , SLOT( wyborGraczy() ) );
    idy_menu[ GRA_START_ID ] = menuGra->insertItem( "&Start" , this , SLOT( zaczynamyGre() ) );
    menuGra->insertSeparator();
    idy_menu[ GRA_KONIEC_PROGRAMU_ID ] = menuGra->insertItem( "&Koniec programu" , qApp , SLOT( quit() ) );

    menuRuch = new QPopupMenu();
    idy_menu[ RUCH_OK_ID ] = menuRuch->insertItem( "&Ok" , this , SLOT( graczNacisnalOk() ) );
    idy_menu[ RUCH_WYMIEN_ID ] = menuRuch->insertItem( "&Wymie" , this , SLOT( graczWymienia() ) );
    idy_menu[ RUCH_PAS_ID ] = menuRuch->insertItem( "&Pas" , this , SLOT( graczSpasowal() ) );

    menuNarzedzia = new QPopupMenu();
    idy_menu[ NARZEDZIA_SCIAGAWKA_ID ] = menuNarzedzia->insertItem( tr( "&cigawka" ) , this , SLOT( obslugaSciagawkiZMenu() ) );
    menuNarzedzia->setCheckable( true );

    menuGracz = new QPopupMenu();
    idy_menu[ GRACZ_DODAJ_ID ] = menuGracz->insertItem( "&Dodaj..." , gracze , SLOT( dodajGracza() ) );
    menuGracz->insertSeparator();
    idy_menu[ GRACZ_O_GRACZACH_ID ] = menuGracz->insertItem( "&Gracze..." , this , SLOT( pokazOGraczach() ) );

    menuOpcje = new QPopupMenu();
    idy_menu[ OPCJE_DORYSOWUJ_OGONKI_ID ] = menuOpcje->insertItem( "&Nie mam polskich liter" , this , SLOT( obslugaOgonkow() ) );
    menuOpcje->setCheckable( true );

    menu = new QMenuBar( this );
    menu->insertItem( "&Gra" , menuGra );
    menu->insertItem( "&Ruch" , menuRuch );
    menu->insertItem( "Gr&acz" , menuGracz );
    menu->insertItem( QString( tr( "&Narzdzia" ) ) , menuNarzedzia );
    menu->insertItem( QString( tr( "&Opcje" ) ) , menuOpcje );

    connect( quit , SIGNAL( clicked() ) , qApp , SLOT( quit() ) );
    connect( start , SIGNAL( clicked() ) , SLOT( zaczynamyGre() ) );
    connect( next , SIGNAL( clicked() ) , SLOT( ruchKomputera() ) );
    connect( stojak , SIGNAL( kliknieteDoWymiany( int ) ) , podsw , SLOT( kliknietoDoWymiany( int ) ) );
    connect( stojak , SIGNAL( kliknietyStojak( int ) ) , podsw , SLOT( kliknietoStojak( int ) ) );
    connect( plansza , SIGNAL( kliknietaPlansze( int , int ) ) , podsw , SLOT( kliknietoPlansze( int , int ) ) );
    connect( plansza , SIGNAL( moznaOkKlikac( int ) ) , SLOT( obslugaOk( int ) ) );
    connect( stojak , SIGNAL( moznaDoWymianyKlikac( int ) ) , SLOT( obslugaWymiana( int ) ) );
    connect( pas , SIGNAL( clicked() ) , SLOT( graczSpasowal() ) );
    connect( wymien , SIGNAL( clicked() ) , SLOT( graczWymienia() ) );
    connect( ok , SIGNAL( clicked() ) , SLOT( graczNacisnalOk() ) );
    connect( nextGame , SIGNAL( clicked() ) , SLOT( wyborGraczy() ) );
    connect( zatwierdzButton , SIGNAL( clicked() ) , SLOT( graczowiSlowoZatwierdzono() ) );
    connect( sprawdzButton , SIGNAL( clicked() ) , SLOT( sprawdzamySlowo() ) );
    connect( zastapBlanka , SIGNAL( kliknietyZastapBlanka( char ) ) , SLOT( zastapionoBlanka( char ) ) );
    connect( zostalo , SIGNAL( kliknietoZamknij() ) , SLOT( obslugaSciagawkiZMenu() ) );
    connect( zostaloLiterButton , SIGNAL( clicked() ) , SLOT( obslugaSciagawkiZMenu() ) );
    connect( gracze , SIGNAL( graczDodany() ) , SLOT( zmajstrujComba() ) );
    connect( graczCombo[0] , SIGNAL( activated( const QString & ) ) , SLOT( obslugaCombo0( const QString & ) ) );
    connect( graczCombo[1] , SIGNAL( activated( const QString & ) ) , SLOT( obslugaCombo1( const QString & ) ) );

    wczytaj_slownik();
    znajdzDlugosci();

    for( int i=0; i<15; i++ )
	pierwszy_wzorzec[i] = NULL;

    wzorzec_z_najlepszym_slowem = NULL;

    inicjuj_wzorce();

    pokazWidgety( DO_WYBORU_GRACZY );
}

Sakreble::~Sakreble()
{
    printf( "Destrukcja...\n");

    gracze->doPliku();

    free( slownik );

    delete literyGracza[0];
    delete literyGracza[1];

    czyscWzorce();
    printf( "I po destrukcji...\n" );
}

void Sakreble::sortujSlowo( char *slowo , int size )
{
    int i, j;
    char pom;
    for( i=1; i<size; i++ )
    {
	j = i;
	while( j > 0 && (unsigned char)slowo[j] < (unsigned char)slowo[j-1] )
	{
	    pom = slowo[j-1];
	    slowo[j-1] = slowo[j];
	    slowo[j] = pom;
	    j--;
	}
    }
}

void Sakreble::wylosujLitery( char *wylosowane , int ile )
{
    int i, j, ktora;

    for( i=0; i<ile; i++ )
    {
	if( wylosowane[i] != PUSTE_POLE )
	    continue;

	if( alfabet.ilePozostaloLiter() == 0 )
	    break;

	ktora = ( random() % alfabet.ilePozostaloLiter() ) + 1;
	alfabet.zmniejszPozostaloLiter();

	j = 0;
	while( ktora > 0 )
	{
	    if( alfabet.litera(j) > 0 )
	    {
		if( alfabet.litera(j) >= ktora )
		{
		    alfabet.zmniejszLitere(j);
		    wylosowane[i] = j;
		    ktora = 0;
		}
		else
		    ktora -= alfabet.litera(j++);
	    }
	    else
		j++;
	}
    }

    pozostaloLabel->setNum( alfabet.ilePozostaloLiter() );
    literyGracza[ ktoryGracz ]->uaktualnijNaRysunku();
    literyGracza[ 1-ktoryGracz ]->uaktualnijNaRysunku();

    if( zostalo->isVisible() )
	zostalo->repaint();
}

void Sakreble::zaczynamyGre()
{
    gracze->ustawKtorzyGraja( 0 , graczCombo[0]->currentText() );
    gracze->ustawKtorzyGraja( 1 , graczCombo[1]->currentText() );

    pokazWidgety( DO_ROZPOCZECIA_PARTII );

    alfabet.inicjujLitery();
    inicjuj_wzorce();
    plansza->czyscPlansze();

    ktoryGracz = 0;

    ile_pauz = 0;
    byl_kit = 0;

    punkty[0]->zerujPunkty();
    punkty[0]->ustawImie( gracze->dajGrajacego(0)->dajImie() );
    punkty[1]->zerujPunkty();
    punkty[1]->ustawImie( gracze->dajGrajacego(1)->dajImie() );

    lampka[0]->zapal();
    lampka[1]->zgas();

    srandom( time( NULL ) );

    literyGracza[0]->kasujLitery();
    literyGracza[1]->kasujLitery();

    wylosujLitery( literyGracza[0]->dajLitery() , 7 );
    wylosujLitery( literyGracza[1]->dajLitery() , 7 );

    if( gracze->dajGrajacego(0)->graczZKrwi() || gracze->dajGrajacego(1)->graczWirtualny() )
	stojak->ustawLiteryNaStojaku( literyGracza[0]->dajLitery() , 7 );
    else
	stojak->ustawLiteryNaStojaku( literyGracza[1]->dajLitery() , 7 );

    if( gracze->dajGrajacego(0)->graczWirtualny() )
    {
        if( gracze->dajGrajacego(1)->graczZKrwi() )
	    ktoryDoSciagawki = 1;

	pokazWidgety( DO_RUCHU_KOMPUTERA );
	ruchKomputera();
    }
    else
    {
	ktoryDoSciagawki = 0;

	pokazWidgety( DO_RUCHU_GRACZA );
    }
}

void Sakreble::ruchKomputera()
{
    sortujSlowo( literyGracza[ ktoryGracz ]->dajLitery() , 7 );
    literyGracza[ktoryGracz]->pustePolaNaKoniec();

    if( plansza->saLitery() )
	produkuj_wzorce_z_planszy(7);
    else
	pierwszy_ruch();

    pokolejkuj_wzorce();
    produkuj_powiazania();

    przejedz_slownik_wzorcami( literyGracza[ ktoryGracz ]->dajLitery() , literyGracza[ktoryGracz]->ileLiter() );

    wzorzec_z_najlepszym_slowem = wybierz_najlepsze_slowo();

    machnij_dolozone_plansze( wzorzec_z_najlepszym_slowem );

    pokazWidgety( DO_ZATWIERDZENIA_SLOWA );
}

void Sakreble::graczowiSlowoZatwierdzono()
{
    if( gracze->dajGrajacego(ktoryGracz)->graczWirtualny() )
    {
	plansza->zdejmijDolozoneLitery();

	machnij_slowo_na_plansze( wzorzec_z_najlepszym_slowem );

	wylosujLitery( literyGracza[ ktoryGracz ]->dajLitery() , 7 );

	czyscWzorce();

	/*
	 * Tu mozna poprawic, poniewaz za bardzo nie widac, jak te pauzy
	 * sie zmieniaja
	 */
	if( wzorzec_z_najlepszym_slowem != NULL )
	    ile_pauz = 0;
	else
	    if( ile_pauz == 4 )
		return;

	byl_kit = 0;
    }
    else
    {
	ile_pauz = 0;
	byl_kit = 0;

	punkty[ktoryGracz]->dodajPunkty( plansza->ilePunktow() );
	plansza->zdejmijDolozenieZDolozonychLiter();

	literyGracza[ktoryGracz]->zmienLitery( stojak->literyNaStojaku() , 7 );
	wylosujLitery( literyGracza[ktoryGracz]->dajLitery() , 7 );

	pozostaloLabel->setNum( alfabet.ilePozostaloLiter() );
    }

    if( literyGracza[ktoryGracz]->ileLiter() > 0 )
    {
	ktoryGracz = 1 - ktoryGracz;

        if( gracze->dajGrajacego(ktoryGracz)->graczZKrwi() )
	    ktoryDoSciagawki = ktoryGracz;

	lampka[ktoryGracz]->zapal();
	lampka[1-ktoryGracz]->zgas();

	if( gracze->dajGrajacego(ktoryGracz)->graczWirtualny() )
	{
	    stojak->ustawLiteryNaStojaku( literyGracza[1-ktoryGracz]->dajLitery() , 7 );
	    pokazWidgety( DO_RUCHU_KOMPUTERA );
	    ruchKomputera();
	}
	else
	{
	    pokazWidgety( DO_RUCHU_GRACZA );
	    stojak->ustawLiteryNaStojaku( literyGracza[ktoryGracz]->dajLitery() , 7 );
	}

	if( zostalo->isVisible() )
	    zostalo->repaint();
    }
    else
	koniecPartii();
}

void Sakreble::sprawdzamySlowo()
{
    if( gracze->dajGrajacego(ktoryGracz)->graczWirtualny() )
	graczowiSlowoZatwierdzono();
    else
    {
	if( byl_kit )
	{
	    byl_kit = 0;
	    graczSpasowal();
	}
	else
	    graczowiSlowoZatwierdzono();
    }
}

void Sakreble::czyscWzorce()
{
    int i, j, k, l;
    struct powiazanie_struct *powpom = NULL, *powprv = NULL;
    struct slowo_struct *slopom = NULL, *sloprv = NULL;

    for( i=0; i<15; i++ )
	for( j=0; j<15; j++ )
	    for( k=0; k<7; k++ )
		for( l=0; l<2; l++ )
		{
		    if( wzorce[i][j][k][l] != NULL )
		    {
			powpom = wzorce[i][j][k][l]->powiazanie;
			while( powpom != NULL )
			{
			    powprv = powpom;
			    powpom = powpom->nastepne;
			    free( powprv );
			}

			slopom = wzorce[i][j][k][l]->slowo;
			while( slopom != NULL )
			{
			    sloprv = slopom;
			    slopom = slopom->nastepne;

			    if( sloprv->blanki )
				delete sloprv->blanki;

			    free( sloprv );
			}

			free( wzorce[i][j][k][l] );
			wzorce[i][j][k][l] = NULL;
		    }
		}
}

int Sakreble::zliczSpacje( char pola[15] )
{
    int i, ile = 0;

    for( i=0; i<15; i++ )
	if( pola[i] == PUSTE_POLE )
	    ile++;

    return ile;
}

void Sakreble::dodaj_wzorzec( int x , int y , char pola[15] , int horyzont )
{
    struct wzorzec_struct *wzopom;
    int i, j;

    /*
     * Wzorzec mogl juz byc dodany do przywiazania.
     */
    if( wzorce[x][y][zliczSpacje(pola)-1][horyzont] == NULL )
    {
	if( ( wzopom = (struct wzorzec_struct *) malloc( sizeof ( struct wzorzec_struct ) ) ) == NULL )
	    fatal( "malloc, dodaj_wzorzec" );
    }
    else
	wzopom = wzorce[x][y][zliczSpacje(pola)-1][horyzont];

    wzopom->dlugosc = 0;

    for( i=0; i<15; i++ )
    {
	wzopom->pola[i] = pola[i];
	wzopom->litery[i] = POZA_GRA;
	if( pola[i] != POZA_GRA )
	    wzopom->dlugosc++;
    }

    j = 0;
    for( i=0; i<wzopom->dlugosc; i++ )
	if( pola[i] != PUSTE_POLE )
	    wzopom->litery[j++] = i;

    wzopom->ile_liter = j;

    j = 0;
    for( i=0; i<wzopom->dlugosc; i++ )
	if( pola[i] == PUSTE_POLE )
	    wzopom->nielitery[j++] = i;

    wzopom->slowo = NULL;
    wzopom->powiazanie = NULL;
    wzopom->nastepny = NULL;
    wzopom->nastepny_identyczny = NULL;

    wzopom->x = x;
    wzopom->y = y;
    wzopom->horyzont = horyzont;

    wzorce[x][y][zliczSpacje( pola )-1][horyzont] = wzopom;
}

void Sakreble::dodaj_powiazanie( struct wzorzec_struct *wzorzec, struct wzorzec_struct *dowiazywany )
{
    struct powiazanie_struct *powpom;

    if( wzorzec == NULL )
	fatal( "Co si pochrzanio, dodaj_powiazanie, wzorzec" );
    if( dowiazywany == NULL )
	fatal( "Co si pochrzanio, dodaj_powiazanie, dowiazywany" );

    if( ( powpom = (struct powiazanie_struct *) malloc( sizeof ( struct powiazanie_struct ) ) ) == NULL )
	fatal( "malloc, dodaj_powiazanie" );

    powpom->wzorzec = dowiazywany;
    powpom->nastepne = wzorzec->powiazanie;
    wzorzec->powiazanie = powpom;;
}

void Sakreble::dodaj_slowo( struct wzorzec_struct *wzorzec, char *slowo, int punkty, int *gdzie_blanki, int ile_blankow )
{
    struct slowo_struct *slopom;

    if( ( slopom = (struct slowo_struct *) malloc( sizeof ( struct slowo_struct ) ) ) == NULL )
	fatal( "malloc, dodaj_slowo" );

    slopom->slowo = slowo;
    slopom->punkty = punkty;

    if( ile_blankow == 0 )
	slopom->blanki = NULL;
    else
    {
	slopom->blanki = new int[ ile_blankow ];

	/*
	 * Blanki sa w odpowiedniej funkcji wciskane tu od konca
	 */
	for( int i=0; i<ile_blankow; i++ )
	    slopom->blanki[i] = gdzie_blanki[ile_blankow - i - 1];
    }

    slopom->nastepne = wzorzec->slowo;
    slopom->ile_blankow = ile_blankow;

    wzorzec->slowo = slopom;
}

void Sakreble::inicjuj_wzorce()
{
    int i, j, k, l;

    for( i=0; i<15; i++ )
	for( j=0; j<15; j++ )
	    for( k=0; k<7; k++ )
		for( l=0; l<2; l++ )
		    wzorce[i][j][k][l] = NULL;
}

void Sakreble::pierwszy_ruch()
{
    int i, j;
    char pola[15];
    
    for( i=0; i<15; i++ )
	if( i<7 )
	    pola[i] = PUSTE_POLE;
	else
	    pola[i] = POZA_GRA;

    for( i=0; i<7-1; i++ ) // -1 bo 1lit nie uznajemy
    {
	for( j=0; j<7-i; j++ )
	{
	    dodaj_wzorzec( 1+j+i , 7 , pola , POZIOMO );
	    dodaj_wzorzec( 7 , 1+j+i , pola , PIONOWO );
	}

	pola[6-i] = POZA_GRA;
    }
    
}

void Sakreble::produkuj_wzorce_z_planszy( char do_ilu_liter )
{
    int i, j, kratka, liter, k;
    char pola[15];
    int bylo_puste, byla_litera;

    for( j=0; j<15; j++ )
	for( i=0; i<15; i++ )
	{
	    /*
	     * Tutaj rozpartujemy poziom
	     */
	    if( i == 0 || plansza->litera( i-1 , j ) == PUSTE_POLE )
	    {
		kratka = 0;
		liter = do_ilu_liter;
		bylo_puste = 0;
		byla_litera = 0;

		for( k=0; k<15; k++ )
		    pola[k] = POZA_GRA;

		while( liter > 0 && kratka + i < 15 )
		{
		    pola[kratka] = alfabet.malaLitera( plansza->litera( kratka+i , j ) );

		    if( pola[kratka] == PUSTE_POLE )
		    {
			if( ( j > 0  && plansza->litera( kratka+i , j-1 ) != PUSTE_POLE ) ||
			    ( j < 14 && plansza->litera( kratka+i , j+1 ) != PUSTE_POLE ) )
				byla_litera = 1;

			bylo_puste = 1;
			liter--;
		    }
		    else
			byla_litera = 1;

		    if( kratka > 0 ) // Sowa przynajmniej 2literowe
			if( bylo_puste && byla_litera )
			    if( kratka+i == 14 || plansza->litera( kratka+i+1 , j ) == PUSTE_POLE )
				dodaj_wzorzec( i , j , pola , POZIOMO );

		    kratka++;
		}
	    }

	    /*
	     * Tutaj rozpartujemy pion
	     */
	    if( j == 0 || plansza->litera( i , j-1 ) == PUSTE_POLE )
	    {
		kratka = 0;
		liter = do_ilu_liter;
		bylo_puste = 0;
		byla_litera = 0;

		for( k=0; k<15; k++ )
		    pola[k] = POZA_GRA;

		while( liter > 0 && kratka + j < 15 )
		{
		    pola[kratka] = alfabet.malaLitera( plansza->litera( i , kratka+j ) );

		    if( pola[kratka] == PUSTE_POLE )
		    {
			if( ( i > 0  && plansza->litera( i-1 , kratka+j ) != PUSTE_POLE ) ||
			    ( i < 14 && plansza->litera( i+1 , kratka+j ) != PUSTE_POLE ) )
				byla_litera = 1;

			bylo_puste = 1;
			liter--;
		    }
		    else
			byla_litera = 1;

		    if( kratka > 0 ) // Sowa przynajmniej 2literowe
			if( bylo_puste && byla_litera )
			    if( kratka+j == 14 || plansza->litera( i , kratka+1+j ) == PUSTE_POLE )
				dodaj_wzorzec( i , j , pola , PIONOWO );

		    kratka++;
		}
	    }
	}
}

void Sakreble::produkuj_powiazania()
{
    struct wzorzec_struct *wzopom, *grupa_wzorcow;
    int j, do_gory, w_bok;

  for( j=0; j<15; j++ )
   for( grupa_wzorcow = pierwszy_wzorzec[j]; grupa_wzorcow != NULL; grupa_wzorcow = grupa_wzorcow->nastepny )
    for( wzopom = grupa_wzorcow; wzopom != NULL; wzopom = wzopom->nastepny_identyczny )
    {
	for( int i=0; i<wzopom->dlugosc; i++ )
	{
	    if( wzopom->horyzont == POZIOMO )
	    {
		if( plansza->litera( wzopom->x+i , (int)wzopom->y ) == PUSTE_POLE )
		{
		    do_gory = 1;

		    while( wzopom->y - do_gory >= 0 && plansza->litera( wzopom->x+i , wzopom->y-do_gory ) != PUSTE_POLE )
			do_gory++;

		    if( wzopom->y > 0 && plansza->litera( wzopom->x+i , wzopom->y-1 ) != PUSTE_POLE )
			dodaj_powiazanie( wzopom , wzorce[wzopom->x+i][wzopom->y-do_gory+1][0][PIONOWO] );
		    else
			if( wzopom->y < 14 && plansza->litera( wzopom->x+i , wzopom->y+1 ) != PUSTE_POLE )
			    dodaj_powiazanie( wzopom , wzorce[wzopom->x+i][(int)wzopom->y][0][PIONOWO] );
		}
	    }
	    else
	    {
		if( plansza->litera( (int)wzopom->x , wzopom->y+i ) == PUSTE_POLE )
		{
		    w_bok = 1;

		    while( wzopom->x - w_bok >= 0 && plansza->litera( wzopom->x-w_bok , wzopom->y+i ) != PUSTE_POLE )
			w_bok++;

		    if( wzopom->x > 0 && plansza->litera( wzopom->x-1 , wzopom->y+i ) != PUSTE_POLE )
			dodaj_powiazanie( wzopom , wzorce[wzopom->x-w_bok+1][wzopom->y+i][0][POZIOMO] );
		    else
			if( wzopom->x < 14 && plansza->litera( wzopom->x+1 , wzopom->y+i ) != PUSTE_POLE )
			    dodaj_powiazanie( wzopom , wzorce[(int)wzopom->x][wzopom->y+i][0][POZIOMO] );
		}
	    }
	}
    }
}

int Sakreble::porownaj_pola_wzorcow( struct wzorzec_struct *w1 , struct wzorzec_struct *w2 )
{
    int i;

    if( w1->dlugosc != w2->dlugosc )
	return 0;

    for( i=0; i<w1->dlugosc; i++ )
	if( w1->pola[i] != w2->pola[i] )
	    return 0;

    return 1;
}

void Sakreble::pokolejkuj_wzorce()
{
    int i, j, k, l;
    struct wzorzec_struct *wzorzec;
    

    for( i=0; i<15; i++ )
	pierwszy_wzorzec[i] = NULL;

    for( i=0; i<15; i++ )
	for( j=0; j<15; j++ )
	    for( k=0; k<7; k++ )
		for( l=0; l<2; l++ )
		    if( wzorce[i][j][k][l] != NULL )
		    {
			wzorzec = pierwszy_wzorzec[wzorce[i][j][k][l]->dlugosc - 1];

			if( wzorzec == NULL )
			    pierwszy_wzorzec[wzorce[i][j][k][l]->dlugosc - 1] = wzorce[i][j][k][l];
			else		
			{	    
			    while( wzorzec != NULL )
			    {
				if( porownaj_pola_wzorcow( wzorzec , wzorce[i][j][k][l] ) )
				{
				    wzorce[i][j][k][l]->nastepny_identyczny = wzorzec->nastepny_identyczny;
				    wzorzec->nastepny_identyczny = wzorce[i][j][k][l];
				    wzorzec = NULL;
				}
				else
				{
				    if( wzorzec->nastepny == NULL )
				    {
					wzorzec->nastepny = wzorce[i][j][k][l];
					wzorzec = NULL;
				    }
				    else
					wzorzec = wzorzec->nastepny;
				}
			    }
			}
		    }
}

void Sakreble::wczytaj_slownik()
{
    FILE *plik;
    size_t size;

    if( ( plik = fopen( PLIK_SLOWNIKA , "r" ) ) == NULL )
	fatal( "fopen, wczytaj_slownik" );

    if( fseek( plik , 0 , SEEK_END ) == -1 )
	fatal( "fseek, wczytaj_slownik" );

    if( ( size = ftell( plik ) ) == (unsigned long)-1 )
	fatal( "ftell, wczytaj_slownik" );

    if( fseek( plik , 0 , SEEK_SET ) == -1 )
	fatal( "fseek, wczytaj_slownik" );

    if( ( slownik = (char *) malloc( sizeof( char ) * size ) ) == NULL )
	fatal( "malloc, wczyatj_slownik" );

    koniec_slownika = slownik + size;

    if( fread( slownik , 1 , size , plik ) != size )
	fatal( "fread, wczytaj_slownik" );

    if( fclose( plik ) != 0 )
	fatal( "fread, wczytaj_slownik" );

    printf( "Sownik wczytany...\n" );
}

void Sakreble::odrzuc_litere_ze_slowa( char *slowo , int size , char litera )
{
    int l, m, r, i;

    l = 0;
    r = size - 1;
    m = ( l + r ) / 2;

    while( slowo[m] != litera )
    {
	if( slowo[m] < litera )
	    l = m + 1;
	else
	    r = m - 1;

	m = ( l + r ) / 2;
    }

    for( i=m+1; i<size; i++ )
	slowo[i-1] = slowo[i];
}

struct wzorzec_struct *Sakreble::wybierz_najlepsze_slowo()
{
    struct wzorzec_struct *wzopom, *najlepszy, *grupa_wzorcow;
    struct slowo_struct *slopom, *poprzednie, *slopow;
    struct powiazanie_struct *powpom;
    int max_punktow = -1, suma_punktow = 0;
    int obciach, sie_znalazlo;
    int j;

    najlepszy = NULL;

  for( j=0; j<15; j++ )
   for( grupa_wzorcow = pierwszy_wzorzec[j]; grupa_wzorcow != NULL; grupa_wzorcow = grupa_wzorcow->nastepny )
    for( wzopom = grupa_wzorcow; wzopom != NULL; wzopom = wzopom->nastepny_identyczny )
    {
	slopom = wzopom->slowo;
	poprzednie = NULL;

	while( slopom != NULL )
	{
	    obciach = 0;
	    suma_punktow = slopom->punkty;

	    /*
	     * Sprawdzamy powiazania.
	     */
	    for( powpom = wzopom->powiazanie; powpom != NULL; powpom = powpom->nastepne )
	    {
		sie_znalazlo = 0;

		for( slopow = powpom->wzorzec->slowo; slopow != NULL; slopow = slopow->nastepne )
		{
		    if( wzopom->horyzont == POZIOMO )
		    {
			if( slopom->slowo[powpom->wzorzec->x - wzopom->x] == slopow->slowo[wzopom->y - powpom->wzorzec->y] )
			{
			    suma_punktow += slopow->punkty;
			    sie_znalazlo = 1;
			}
		    }
		    else
		    {
			if( slopom->slowo[powpom->wzorzec->y - wzopom->y] == slopow->slowo[wzopom->x - powpom->wzorzec->x] )
			{
			    suma_punktow += slopow->punkty;
			    sie_znalazlo = 1;
			}
		    }
		}

		if( !sie_znalazlo )
		    obciach = 1;
	    }

	    if( !obciach && suma_punktow > max_punktow )
	    {
		if( slopom->blanki && ( gracze->dajGrajacego( ktoryGracz )->dajOplacalnoscBlanka() >= suma_punktow ) && alfabet.ilePozostaloLiter() > 0 )
		{
		    poprzednie = slopom;
		    slopom = slopom->nastepne;
		}
		else
		{
		    max_punktow = suma_punktow;
		    if( poprzednie != NULL )
		    {
			poprzednie->nastepne = slopom->nastepne;
			slopom->nastepne = wzopom->slowo;
			wzopom->slowo = slopom;
			slopom = poprzednie->nastepne;
		    }
		    else
		    {
			poprzednie = slopom;
			slopom = slopom->nastepne;
		    }
		    najlepszy = wzopom;
		}
	    }
	    else
	    {
		poprzednie = slopom;
		slopom = slopom->nastepne;
	    }
	}
    }

    if( max_punktow >= 0 )
	najlepszy->slowo->punkty = max_punktow;

    return najlepszy;
}

void Sakreble::przejedz_slownik_wzorcami( char *litery , int ile_liter )
{
    char *slowo = slownik, *pocz = slownik;
    int dlugosc_slowa = 0, i;
    struct wzorzec_struct *wzorzec = NULL, *identyczny;
    int aktx, akty, uzytych_liter, punkty, mnoznik_slowa, slowo_pasuje;
    int ile_blankow = 0, zostalo_blankow;
    Sprawdzacz sprawdzacz;

    int min_dlugosc = gracze->dajGrajacego( ktoryGracz )->dajMinSlowa();
    int max_dlugosc = gracze->dajGrajacego( ktoryGracz )->dajMaxSlowa();
/*
litery[0]='#';
litery[1]='#';
litery[2]='i';
litery[3]='l';
litery[4]='s';
litery[5]='w';
litery[6]='';
*/
    for( i=0; i<ile_liter; i++ )
    {
	if( litery[i] == BLANK )
	    ile_blankow++;

	printf("%c",litery[i]);
    }
printf("\n");

    litery += ile_blankow;
    ile_liter -= ile_blankow;

    int gdzie_blank[ ile_blankow ];

    sprawdzacz.ustawKtoreLitery( litery , ile_liter );

    while( slowo < koniec_slownika )
    {
	if( *slowo == 10 )
	{
	    if( dlugosc_slowa < min_dlugosc || dlugosc_slowa > max_dlugosc )
	    {
		slowo++;
		continue;
	    }

	    for( wzorzec = pierwszy_wzorzec[dlugosc_slowa-1]; wzorzec != NULL; wzorzec = wzorzec->nastepny )
	    {
		    slowo_pasuje = 1;

			/*
                         * Najpierw sprawdzam, czy we wzorcu sa jakies litery i czy w slowie tez one sa
                         */
			for( i=0; i<wzorzec->ile_liter; i++ )
			{
			    if( wzorzec->pola[(int)wzorzec->litery[i]] != pocz[(int)wzorzec->litery[i]] )
			    {
				slowo_pasuje = 0;
				break;
			    }
			}

			if( slowo_pasuje )
			{
			    sprawdzacz.ustawLitery( litery , ile_liter );

			    zostalo_blankow = ile_blankow;

			    /* Tutaj probujemy dopasowac nasze literki do slowa */
			    for( i=0; i < wzorzec->dlugosc - wzorzec->ile_liter; i++ )
				if( sprawdzacz.odejmijLiterke( pocz[(int)wzorzec->nielitery[i]] ) && zostalo_blankow )
				    gdzie_blank[ --zostalo_blankow ] = (int)wzorzec->nielitery[i];

			    slowo_pasuje = sprawdzacz.dobreSlowo( wzorzec->dlugosc - wzorzec->ile_liter - ( ile_blankow - zostalo_blankow ) );
			}

		    if( slowo_pasuje )
		    {
//for( i=0;i<dlugosc_slowa; i++)printf("%c",pocz[i]);printf("\n");

			for( identyczny = wzorzec; identyczny != NULL; identyczny = identyczny->nastepny_identyczny )
			{
		    	    punkty = 0;	    
		    	    mnoznik_slowa = 1;
		    	    aktx = identyczny->x;
		    	    akty = identyczny->y;
		    	    uzytych_liter = 0;

			    for( i=zostalo_blankow; i<ile_blankow; i++ )
			    {
				pocz[ gdzie_blank[i] ] = alfabet.wielkaLitera( pocz[ gdzie_blank[i] ] );
//printf("%d %c\n",gdzie_blank[i],pocz[gdzie_blank[i]]);
			    }
		    	
			    for( i=0; i<dlugosc_slowa; i++ )
		    	    {
				if( plansza->litera( aktx , akty ) == PUSTE_POLE )
				{
//printf("%c %d\n",pocz[i],alfabet.dajPunktyLitery(pocz[i]));
			    	    switch( plansza->premia( aktx , akty ) )
			    	    {
					case NORMAL:
				    	    punkty += alfabet.dajPunktyLitery( (unsigned char)pocz[i] );
					    break;
					case DWAL:
				    	    punkty += 2 * alfabet.dajPunktyLitery( (unsigned char)pocz[i] );
				    	    break;
					case TRZYL:
				    	    punkty += 3 * alfabet.dajPunktyLitery( (unsigned char)pocz[i] );
				    	    break;
					case DWAS:
				    	    mnoznik_slowa *= 2;
				    	    punkty += alfabet.dajPunktyLitery( (unsigned char)pocz[i] );
				    	    break;
			    		case TRZYS:
				    	    mnoznik_slowa *= 3;
				    	    punkty += alfabet.dajPunktyLitery( (unsigned char)pocz[i] );
				    	    break;
					default:;
				    }

				    uzytych_liter++;
				}
				else
			    	    punkty += alfabet.dajPunktyLitery( plansza->litera( aktx , akty ) );

				if( identyczny->horyzont == POZIOMO )
			    	    aktx++;
				else
			    	    akty++;
			    }

			    punkty *= mnoznik_slowa;

			    if( uzytych_liter == 7 )
				punkty += 50;

			    dodaj_slowo( identyczny , pocz , punkty , gdzie_blank , ile_blankow-zostalo_blankow );

			    for( i=zostalo_blankow; i<ile_blankow; i++ )
				pocz[ gdzie_blank[i] ] = alfabet.malaLitera( pocz[ gdzie_blank[i] ] );
			}
		    }
	    }

	    dlugosc_slowa = 0;
	    pocz = slowo + 1;
	}
	else
	    dlugosc_slowa++;

	slowo++;
    }
}

void Sakreble::machnij_dolozone_plansze( struct wzorzec_struct *wzorzec )
{
    int i, aktx, akty, ktory_blank = 0;

    if( wzorzec != NULL )
    {
	aktx = wzorzec->x;
	akty = wzorzec->y;

	for( i=0; i<wzorzec->dlugosc; i++ )
	{
	    if( plansza->litera( aktx , akty ) == PUSTE_POLE )
		if( wzorzec->slowo->blanki && ktory_blank < wzorzec->slowo->ile_blankow )
		{
		    if( wzorzec->slowo->blanki[ktory_blank] == i )
		    {
			ktory_blank++;
			plansza->podswietlLitereUstawionaPrzezKomputer( alfabet.duzaLitera( wzorzec->slowo->slowo[i] ) , aktx , akty );
		    }
		    else
			plansza->podswietlLitereUstawionaPrzezKomputer( wzorzec->slowo->slowo[i] , aktx , akty );
		}
		else
		    plansza->podswietlLitereUstawionaPrzezKomputer( wzorzec->slowo->slowo[i] , aktx , akty );

	    if( wzorzec->horyzont == POZIOMO )
		aktx++;
	    else
		akty++;
	}
    }

    ten_ruch->zerujPunkty();
    ten_ruch->dodajPunkty( plansza->ilePunktow() );
}

/*
 * To jest funkcja wywolywana jedynie przy ruchu komputera !!!
 */
void Sakreble::machnij_slowo_na_plansze( struct wzorzec_struct *wzorzec )
{
    int i, aktx, akty, ktory_blank = 0;

    if( wzorzec != NULL )
    {
	ile_pauz = 0;

	aktx = wzorzec->x;
	akty = wzorzec->y;

	for( i=0; i<wzorzec->dlugosc; i++ )
	{
	    if( plansza->litera( aktx , akty ) == PUSTE_POLE )
	    {
		if( wzorzec->slowo->blanki )
		{
		    if( wzorzec->slowo->blanki[ktory_blank] == i )
		    {
			ktory_blank++;
			plansza->ustawLitere( alfabet.duzaLitera( wzorzec->slowo->slowo[i] ) , aktx , akty );
			literyGracza[ ktoryGracz ]->kasujLitere( BLANK );
		    }
		    else
			plansza->ustawLitere( wzorzec->slowo->slowo[i] , aktx , akty );
			literyGracza[ ktoryGracz ]->kasujLitere( wzorzec->slowo->slowo[i] );
		}
		else
		{
		    plansza->ustawLitere( wzorzec->slowo->slowo[i] , aktx , akty );
		    literyGracza[ ktoryGracz ]->kasujLitere( wzorzec->slowo->slowo[i] );
		}
	    }

	    if( wzorzec->horyzont == POZIOMO )
		aktx++;
	    else
		akty++;
	}

	punkty[ ktoryGracz ]->dodajPunkty( wzorzec->slowo->punkty );
	ten_ruch->ustawPunkty( wzorzec->slowo->punkty );
    }
    else
    {
	if( ++ile_pauz == 4 )
	{
	    koniecPartii();
	    return;
	}

	ten_ruch->ustawPunkty( 0 );
    }

    if( gracze->dajGrajacego(ktoryGracz)->graczZKrwi() )
	literyGracza[ ktoryGracz ]->zmienLitery( stojak->literyNaStojaku() , 7 );
}

void Sakreble::znajdzDlugosci()
{
    int dlugosc_slowa = 0;
    char *slowo = slownik, *pocz = slownik;

    for( int i=0; i<15; i++ )
	dlugosci[i] = NULL;

    while( slowo < koniec_slownika )
    {
	if( *slowo == 10 )
	{
	    if( dlugosci[dlugosc_slowa-1] == NULL )
		dlugosci[dlugosc_slowa-1] = pocz;

	    dlugosc_slowa = 0;
	    pocz = slowo + 1;
	}
	else
	    dlugosc_slowa++;

	slowo++;
    }
}

int Sakreble::porownajSlowa( char *s1 , char *s2 , int d )
{
/*    for( int i=0; i<d; i++ )
	printf( "%c" , s1[i] );
    printf(" ");
    for( int i=0; i<d; i++ )
	printf( "%c" , s2[i] );
    printf(" porownuje...\n");
*/
    for( int i=0; i<d; i++ )
	if( (unsigned char)s1[i] < (unsigned char)s2[i] )
	    return -1;
	else
	    if( (unsigned char)s1[i] > (unsigned char)s2[i] )
	    return 1;

    return 0;
}


int Sakreble::slowoJestWSlowniku( char *slowo , int dlugosc )
{
    char *left, *mid = NULL, *right;
    int por = 0;

    left = dlugosci[dlugosc-1];

    if( left == NULL )
	return 0;

    if( dlugosc == 15 )
	right = koniec_slownika;
    else
    {
	if( dlugosci[dlugosc] != NULL )
	    right = dlugosci[dlugosc];
	else
	    right = koniec_slownika;
    }

    while( left < right )
    {
	mid = (char *)(( (unsigned long)left + (unsigned long)right ) / 2);

	while( mid > left && *(mid - 1) != 10 )
	    mid--;

	if( ( por = porownajSlowa( slowo , mid , dlugosc) ) == 0 )
	    return 1;

	if( por == 1 )
	    left = mid + dlugosc + 1;
	else
	    right = mid;
    }

    return 0;
}

void Sakreble::obslugaOk( int enb )
{
    if( !enb )
    {
	ok->setEnabled( false );
	menuRuch->setItemEnabled( idy_menu[ RUCH_OK_ID ] , false );

	ten_ruch->zerujPunkty();

	if( stojak->saLiteryDoWymiany() && !plansza->saLiteryDolozone() && alfabet.ilePozostaloLiter() >= 7 )
	{
	    wymien->setEnabled( true );
	    menuRuch->setItemEnabled( idy_menu[ RUCH_WYMIEN_ID ] , true );
	}
	else
	{
	    wymien->setEnabled( false );
	    menuRuch->setItemEnabled( idy_menu[ RUCH_WYMIEN_ID ] , false );
	}

	return;
    }

    if( stojak->saLiteryDoWymiany() )
    {
	wymien->setEnabled( false );
	menuRuch->setItemEnabled( idy_menu[ RUCH_WYMIEN_ID ] , false );
    }
    else
	if( plansza->litera( 7 , 7 ) != PUSTE_POLE )
	{
	    ok->setEnabled( true );
	    menuRuch->setItemEnabled( idy_menu[ RUCH_OK_ID ] , true );

	    ten_ruch->zerujPunkty();
	    ten_ruch->dodajPunkty( plansza->ilePunktow() );
	}
}

void Sakreble::obslugaWymiana( int enb )
{
    if( !enb )
    {
	wymien->setEnabled( false );
	menuRuch->setItemEnabled( idy_menu[ RUCH_WYMIEN_ID ] , false );

	if( plansza->poprawnieDolozoneSlowo() )
	    if( plansza->litera( 7 , 7 ) != PUSTE_POLE )
	    {
		ok->setEnabled( true );
		menuRuch->setItemEnabled( idy_menu[ RUCH_OK_ID ] , true );

		ten_ruch->zerujPunkty();
		ten_ruch->dodajPunkty( plansza->ilePunktow() );
	    }

	return;
    }

    if( plansza->saLiteryDolozone() )
    {
	ok->setEnabled( false );
	menuRuch->setItemEnabled( idy_menu[ RUCH_OK_ID ] , false );

	ten_ruch->zerujPunkty();
    }
    else
	if( alfabet.ilePozostaloLiter() >= 7 )
	{
	    wymien->setEnabled( true );
	    menuRuch->setItemEnabled( idy_menu[ RUCH_WYMIEN_ID ] , true );
	}
}

void Sakreble::graczSpasowal()
{
    podsw->wylaczPodswietlenie();

    plansza->zdejmijDolozoneLitery();
    stojak->zdejmijLiteryDoWymiany();
    stojak->ustawLiteryNaStojaku( literyGracza[ktoryGracz]->dajLitery() , 7 );

    if( ++ile_pauz == 4 )
    {
	koniecPartii();
	return;
    }

    if( gracze->dajGrajacego(1-ktoryGracz)->graczWirtualny() )
    {
	pokazWidgety( DO_RUCHU_KOMPUTERA );

	ktoryGracz = 1 - ktoryGracz;

        if( gracze->dajGrajacego(ktoryGracz)->graczZKrwi() )
	    ktoryDoSciagawki = ktoryGracz;

	lampka[ktoryGracz]->zapal();
	lampka[1-ktoryGracz]->zgas();

	ruchKomputera();
    }
    else
    {
	ktoryGracz = 1 - ktoryGracz;

        if( gracze->dajGrajacego(ktoryGracz)->graczZKrwi() )
	    ktoryDoSciagawki = ktoryGracz;

	lampka[ktoryGracz]->zapal();
	lampka[1-ktoryGracz]->zgas();

	pokazWidgety( DO_RUCHU_GRACZA );

	stojak->ustawLiteryNaStojaku( literyGracza[ktoryGracz]->dajLitery() , 7 );
    }

    if( zostalo->isVisible() )
	zostalo->repaint();
}

void Sakreble::graczWymienia()
{
    podsw->wylaczPodswietlenie();

    literyGracza[ktoryGracz]->zmienLitery( stojak->literyNaStojaku() , 7 );
    wylosujLitery( literyGracza[ktoryGracz]->dajLitery() , 7 );

    for( int i=0; i<7; i++ )
	if( stojak->literaDoWymiany( i ) != PUSTE_POLE )
	{
	    alfabet.zwiekszLitere( stojak->literaDoWymiany( i ) );
	    alfabet.zwiekszPozostaloLiter();
	}
    pozostaloLabel->setNum( alfabet.ilePozostaloLiter() );

    stojak->zdejmijLiteryDoWymiany();

    if( gracze->dajGrajacego(1-ktoryGracz)->graczWirtualny() )
    {
	ktoryGracz = 1 - ktoryGracz;

        if( gracze->dajGrajacego(ktoryGracz)->graczZKrwi() )
	    ktoryDoSciagawki = ktoryGracz;

	lampka[ktoryGracz]->zapal();
	lampka[1-ktoryGracz]->zgas();

	pokazWidgety( DO_RUCHU_KOMPUTERA );

	stojak->ustawLiteryNaStojaku( literyGracza[1-ktoryGracz]->dajLitery() , 7 );

	ruchKomputera();
    }
    else
    {
	ktoryGracz = 1 - ktoryGracz;

        if( gracze->dajGrajacego(ktoryGracz)->graczZKrwi() )
	    ktoryDoSciagawki = ktoryGracz;

	lampka[ktoryGracz]->zapal();
	lampka[1-ktoryGracz]->zgas();

	pokazWidgety( DO_RUCHU_GRACZA );

	stojak->ustawLiteryNaStojaku( literyGracza[ktoryGracz]->dajLitery() , 7 );
    }

    if( zostalo->isVisible() )
        zostalo->repaint();
}

void Sakreble::graczNacisnalOk()
{
    podsw->wylaczPodswietlenie();

    if( plansza->polozonyBlank() )
    {
	plansza->zapalBlanka();
	pokazWidgety( DO_ZASTAPIENIA_BLANKA );
    }
    else
	graczUkladaSlowo();
}

void Sakreble::zastapionoBlanka( char na_co )
{
    plansza->zgasBlanka();
    plansza->zastapBlanka( na_co );

    if( plansza->polozonyBlank() )
    {
	plansza->zapalBlanka();
	pokazWidgety( DO_ZASTAPIENIA_BLANKA );
    }
    else
	graczUkladaSlowo();
}

void Sakreble::graczUkladaSlowo()
{
    int pierwx = -1, pierwy = -1, horyzont = POZIOMO;
    int do_gory = 0, w_lewo = 0, pkt = 0;
    int dolozona_druga = 0;

    byl_kit = 0;

    for( int i=0; i<15; i++ )
	for( int j=0; j<15; j++ )
	    if( plansza->literaDolozona( i , j ) )
	    {
		if( pierwx == -1 )
		{
		    pierwx = i;
		    pierwy = j;
		}

		break;
	    }

    for( int i=pierwx+1; i<15; i++ )
	if( plansza->literaDolozona( i , pierwy ) )
	{
	    horyzont = POZIOMO;
	    dolozona_druga = 1;
	    break;
	}

    if( !dolozona_druga )
	for( int j=pierwy+1; j<15; j++ )
	    if( plansza->literaDolozona( pierwx , j ) )
	    {
		horyzont = PIONOWO;
		dolozona_druga = 1;
		break;
	    }

    if( !dolozona_druga )
    {
	if( pierwx > 0 && plansza->litera( pierwx - 1 , pierwy ) != PUSTE_POLE )
	    horyzont = POZIOMO;

	if( pierwx < 14 && plansza->litera( pierwx + 1 , pierwy ) != PUSTE_POLE )
	    horyzont = POZIOMO;

	if( pierwy > 0 && plansza->litera( pierwx , pierwy - 1 ) != PUSTE_POLE )
	    horyzont = PIONOWO;

	if( pierwy < 14 && plansza->litera( pierwx , pierwy + 1 ) != PUSTE_POLE )
	    horyzont = PIONOWO;
    }

    if( horyzont == POZIOMO )
	while( pierwx > 0 && plansza->litera( pierwx - 1 , pierwy ) != PUSTE_POLE )
	    pierwx--;
    else
	while( pierwy > 0 && plansza->litera( pierwx , pierwy - 1 ) != PUSTE_POLE )
	    pierwy--;

    if( slowoZPlanszyJestWSlowniku( pierwx , pierwy , horyzont ) )
	pkt += plansza->ilePunktow( pierwx , pierwy , horyzont );
    else
	byl_kit = 1;

    while( pierwx < 15 && pierwy < 15 )
    {
	if( plansza->litera( pierwx , pierwy ) == PUSTE_POLE )
	    break;

	if( plansza->literaDolozona( pierwx , pierwy ) )
	{
	    if( horyzont == POZIOMO )
	    {
		do_gory = 0;
		while( pierwy-do_gory-1 >= 0 )
		    if( plansza->litera( pierwx , pierwy-do_gory-1 ) != PUSTE_POLE )
			do_gory++;
		    else
			break;

		if( do_gory > 0 || ( pierwy < 14 && plansza->litera( pierwx , pierwy + 1 ) != PUSTE_POLE ) )
		{
		    if( slowoZPlanszyJestWSlowniku( pierwx , pierwy-do_gory , PIONOWO ) )
			pkt += plansza->ilePunktow( pierwx , pierwy-do_gory , PIONOWO );
		    else
			byl_kit = 1;
		}
	    }
	    else
	    {
		w_lewo = 0;
		while( pierwx-w_lewo-1 >= 0 )
		    if( plansza->litera( pierwx-w_lewo-1 , pierwy ) != PUSTE_POLE )
			w_lewo++;
		    else
			break;

		if( w_lewo > 0 || ( pierwx < 14 && plansza->litera( pierwx + 1 , pierwy ) != PUSTE_POLE ) )
		{
		    if( slowoZPlanszyJestWSlowniku( pierwx-w_lewo , pierwy , POZIOMO ) )
			pkt += plansza->ilePunktow( pierwx-w_lewo , pierwy , POZIOMO );
		    else
			byl_kit = 1;
		}
	    }
	}

	if( horyzont == POZIOMO )
	    pierwx++;
	else
	    pierwy++;
    }

    if( gracze->dajGrajacego(1-ktoryGracz)->graczWirtualny() )
	sprawdzamySlowo();
    else
	pokazWidgety( DO_ZATWIERDZENIA_SLOWA );
}

int Sakreble::slowoZPlanszyJestWSlowniku( int i , int j , int horyzont )
{
    char slowo[15];
    int dlugosc = 0;

    while( i < 15 && j < 15 )
    {
	if( plansza->litera( i , j ) != PUSTE_POLE )
	    slowo[ dlugosc++ ] = alfabet.malaLitera( plansza->litera( i , j ) );
	else
	    break;

	if( horyzont == POZIOMO )
	    i++;
	else
	    j++;
    }

    return slowoJestWSlowniku( slowo , dlugosc );
}

void Sakreble::pokazWidgety( int do_czego )
{
    switch( do_czego )
    {
	case DO_RUCHU_GRACZA:
	    ok->show();
	    wymien->show();
	    pas->show();
	    ok->setEnabled( false );
	    wymien->setEnabled( false );
	    stojak->setEnabled( true );
	    next->hide();
	    sprawdzButton->hide();
	    zatwierdzButton->hide();

	    if( !zostalo->isVisible() )
		zostaloLiterButton->setEnabled( true );
	    menuNarzedzia->setItemEnabled( idy_menu[ NARZEDZIA_SCIAGAWKA_ID ] , true );

	    menuRuch->setItemEnabled( idy_menu[ RUCH_OK_ID ] , false );
	    menuRuch->setItemEnabled( idy_menu[ RUCH_WYMIEN_ID ] , false );
	    menuRuch->setItemEnabled( idy_menu[ RUCH_PAS_ID ] , true );

	    break;

	case DO_RUCHU_KOMPUTERA:
	    ok->hide();
	    wymien->hide();
	    pas->hide();
	    stojak->setEnabled( false );
	    next->show();
	    sprawdzButton->hide();
	    zatwierdzButton->hide();
	    zostaloLiterButton->setEnabled( false );
	    menuNarzedzia->setItemEnabled( idy_menu[ NARZEDZIA_SCIAGAWKA_ID ] , false );

	    menuRuch->setItemEnabled( idy_menu[ RUCH_OK_ID ] , false );
	    menuRuch->setItemEnabled( idy_menu[ RUCH_PAS_ID ] , false );
	    menuRuch->setItemEnabled( idy_menu[ RUCH_WYMIEN_ID ] , false );

	    break;

	case DO_WYBORU_GRACZY:
	    ok->hide();
	    wymien->hide();
	    pas->hide();
	    next->hide();
	    nextGame->hide();
	    stojak->setEnabled( false );
	    plansza->setEnabled( false );
	    for( int i=0; i<2; i++ )
	    {
		graczCombo[i]->show();
		graczCombo[i]->setEnabled( true );
		punkty[i]->hide();
		literyGracza[i]->hide();
		lampka[i]->hide();
	    }
	    ten_ruch->hide();
	    label->show();
	    start->show();
	    sprawdzButton->hide();
	    zatwierdzButton->hide();

	    menuGra->setItemEnabled( idy_menu[ GRA_START_ID ] , true );
	    menuRuch->setItemEnabled( idy_menu[ RUCH_OK_ID ] , false );
	    menuRuch->setItemEnabled( idy_menu[ RUCH_PAS_ID ] , false );
	    menuRuch->setItemEnabled( idy_menu[ RUCH_WYMIEN_ID ] , false );

	    if( menuNarzedzia->isItemChecked( idy_menu[ NARZEDZIA_SCIAGAWKA_ID ] ) )
	    {
		menuNarzedzia->setItemChecked( idy_menu[ NARZEDZIA_SCIAGAWKA_ID ] , false );
		zostalo->hide();
		zostaloLiterButton->hide();
	    }
	    menuNarzedzia->setItemEnabled( idy_menu[ NARZEDZIA_SCIAGAWKA_ID ] , false );

	    break;

	case DO_ROZPOCZECIA_PARTII:
	    for( int i=0; i<2; i++ )
	    {
		graczCombo[i]->hide();
		graczCombo[i]->setEnabled( false );
		punkty[i]->show();
		literyGracza[i]->show();
		lampka[i]->show();
	    }
	    ten_ruch->show();
	    zostaloLiterButton->show();

	    if( gracze->dajGrajacego(0)->graczWirtualny() )
	    {
		zostaloLiterButton->setEnabled( true );
		menuNarzedzia->setItemEnabled( idy_menu[ NARZEDZIA_SCIAGAWKA_ID ] , true );
	    }
	    else
	    {
		zostaloLiterButton->setEnabled( false );
		menuNarzedzia->setItemEnabled( idy_menu[ NARZEDZIA_SCIAGAWKA_ID ] , false );
	    }

	    zostalo->hide();
	    label->hide();
	    start->hide();
	    plansza->setEnabled( true );
	    sprawdzButton->hide();
	    zatwierdzButton->hide();

	    menuGra->setItemEnabled( idy_menu[ GRA_START_ID ] , false );

	    break;

	case DO_ZAKONCZENIA_PARTII:
	    ok->hide();
	    wymien->hide();
	    pas->hide();
	    next->hide();
	    nextGame->show();
	    stojak->setEnabled( false );
	    plansza->setEnabled( false );
	    sprawdzButton->hide();
	    zatwierdzButton->hide();
	    zostaloLiterButton->hide();

	    if( menuNarzedzia->isItemChecked( idy_menu[ NARZEDZIA_SCIAGAWKA_ID ] ) )
	    {
		menuNarzedzia->setItemChecked( idy_menu[ NARZEDZIA_SCIAGAWKA_ID ] , false );
		zostalo->hide();
	    }
	    menuNarzedzia->setItemEnabled( idy_menu[ NARZEDZIA_SCIAGAWKA_ID ] , false );

	    menuRuch->setItemEnabled( idy_menu[ RUCH_OK_ID ] , false );
	    menuRuch->setItemEnabled( idy_menu[ RUCH_PAS_ID ] , false );
	    menuRuch->setItemEnabled( idy_menu[ RUCH_WYMIEN_ID ] , false );

	    break;

	case DO_ZATWIERDZENIA_SLOWA:
	    ok->hide();
	    wymien->hide();
	    pas->hide();
	    next->hide();
	    stojak->setEnabled( false );
	    sprawdzButton->show();
	    zatwierdzButton->show();

	    menuRuch->setItemEnabled( idy_menu[ RUCH_OK_ID ] , false );
	    menuRuch->setItemEnabled( idy_menu[ RUCH_PAS_ID ] , false );
	    menuRuch->setItemEnabled( idy_menu[ RUCH_WYMIEN_ID ] , false );

	    break;

	case DO_ZASTAPIENIA_BLANKA:
	    zastapBlanka->show();

	default:;
    }
}

void Sakreble::koniecPartii()
{
    int zostalo[2];
    int ranking[2];
    int wygrana = 1;

    lampka[ktoryGracz]->zgas();
    lampka[1-ktoryGracz]->zgas();

    pokazWidgety( DO_ZAKONCZENIA_PARTII );

    zostalo[0] = zostalo[1] = 0;

    for( int gr=0; gr<2; gr++ )
	for( int i=0; i<7; i++ )
	    if( literyGracza[gr]->litera(i) != PUSTE_POLE )
		zostalo[gr] += alfabet.dajPunktyLitery( literyGracza[gr]->litera(i) );

    ranking[0] = (int) gracze->dajGrajacego(0)->ranking();
    ranking[1] = (int) gracze->dajGrajacego(1)->ranking();

    if( literyGracza[ktoryGracz]->ileLiter() == 0 )
    {
	punkty[ktoryGracz]->dodajPunkty( zostalo[1-ktoryGracz] );
	punkty[1-ktoryGracz]->dodajPunkty( -zostalo[1-ktoryGracz] );
    }
    else
    {
	punkty[ktoryGracz]->dodajPunkty( -zostalo[ktoryGracz] );
	punkty[1-ktoryGracz]->dodajPunkty( -zostalo[1-ktoryGracz] );
    }

    /*
     * Uaktualniamy graczom rankingi
     */
    if( punkty[ktoryGracz]->podajPunkty() < punkty[1-ktoryGracz]->podajPunkty() )
	ktoryGracz = 1-ktoryGracz;
    else
    {
	if( punkty[ktoryGracz]->podajPunkty() == punkty[1-ktoryGracz]->podajPunkty() )
	    wygrana = 0; // Byl remis
	else
	    wygrana = 1; // Czyjas wygrana
    }

    if( ranking[ktoryGracz] - ranking[1-ktoryGracz] <= 50 )
    {
	gracze->dajGrajacego( ktoryGracz )->dodajSkalp( ranking[1-ktoryGracz] + 50*wygrana );
	gracze->dajGrajacego( 1-ktoryGracz )->dodajSkalp( ranking[ktoryGracz] - 50*wygrana );
    }
    else
    {
	gracze->dajGrajacego( ktoryGracz )->dodajSkalp( ranking[ktoryGracz] );
	gracze->dajGrajacego( 1-ktoryGracz )->dodajSkalp( ranking[1-ktoryGracz] );
    }
}

void Sakreble::wyborGraczy()
{
    pokazWidgety( DO_WYBORU_GRACZY );
}

void Sakreble::obslugaSciagawkiZMenu()
{
    if( menuNarzedzia->isItemChecked( idy_menu[ NARZEDZIA_SCIAGAWKA_ID ] ) )
    {
	menuNarzedzia->setItemChecked( idy_menu[ NARZEDZIA_SCIAGAWKA_ID ] , false );
	zostalo->hide();
	zostaloLiterButton->setEnabled( true );
    }
    else
    {
	menuNarzedzia->setItemChecked( idy_menu[ NARZEDZIA_SCIAGAWKA_ID ] , true );
	zostalo->show();
	zostaloLiterButton->setEnabled( false );
    }
}

void Sakreble::imionaGraczyDoCombo( int ktorego )
{
    graczCombo[ktorego]->clear();

    for( int i=0; i<gracze->iluGraczy(); i++ )
    {
	QString s;

	if( (*gracze)[i].graczWirtualny() )
	    s.sprintf( "* %s" , (*gracze)[i].dajImie() );
	else
	    s.sprintf( "  %s" , (*gracze)[i].dajImie() );

        graczCombo[ktorego]->insertItem( s , -1 );
    }
}

void Sakreble::imionaGraczyDoCombow()
{
    imionaGraczyDoCombo( 0 );
    imionaGraczyDoCombo( 1 );
}

/*
 * Tutaj dbam o to, by gracz nie mogl grac sam ze soba - po prostu nie bedzie
 * mial do wyboru samego siebie
 */
void Sakreble::obslugaCombow( int ktoryGracz , const QString &imie )
{
    QString com1 = graczCombo[1-ktoryGracz]->currentText();
    QString com0 = graczCombo[ktoryGracz]->currentText();

    imionaGraczyDoCombow();

    /*
     * Najpierw obu graczom usuwam ich adwersarzy
     */
    for( int i=0; i<graczCombo[ktoryGracz]->count(); i++ )
	if( graczCombo[ktoryGracz]->text(i) == com1 )
	{
	    graczCombo[ktoryGracz]->removeItem(i);

	    break;
	}

    for( int i=0; i<graczCombo[1-ktoryGracz]->count(); i++ )
	if( graczCombo[1-ktoryGracz]->text(i) == com0 )
	{
	    graczCombo[1-ktoryGracz]->removeItem(i);

	    break;
	}

    /*
     * Potem temu drugiemu ustawiam, co tam mial na poczatku
     */
    for( int i=0; i<graczCombo[1-ktoryGracz]->count(); i++ )
	if( graczCombo[1-ktoryGracz]->text(i) == com1 )
	{
	    graczCombo[1-ktoryGracz]->setCurrentItem(i);

	    break;
	}

    /*
     * A na koncu w tym, co sie wybor zmienil ustawiam na to, co wybrano
     */
    for( int i=0; i<graczCombo[ktoryGracz]->count(); i++ )
	if( graczCombo[ktoryGracz]->text(i) == imie )
	{
	    graczCombo[ktoryGracz]->setCurrentItem(i);

	    break;
	}
}

void Sakreble::obslugaCombo0( const QString &imie )
{
    obslugaCombow( 0 , imie );
}

void Sakreble::obslugaCombo1( const QString &imie )
{
    obslugaCombow( 1 , imie );
}

void Sakreble::zmajstrujComba()
{
    obslugaCombow( 0 , graczCombo[0]->currentText() );
}

void Sakreble::obslugaOgonkow()
{
    if( menuOpcje->isItemChecked( idy_menu[ OPCJE_DORYSOWUJ_OGONKI_ID ] ) )
    {
	menuOpcje->setItemChecked( idy_menu[ OPCJE_DORYSOWUJ_OGONKI_ID ] , false );
	alfabet.ustawPolskie( false );
    }
    else
    {
	menuOpcje->setItemChecked( idy_menu[ OPCJE_DORYSOWUJ_OGONKI_ID ] , true );
	alfabet.ustawPolskie( true );
    }

    plansza->repaint();
    stojak->repaint();
    zostalo->repaint();    
}

void Sakreble::pokazOGraczach()
{
    oGraczach->show();
}
