#ifndef SAKREBLE_H
#define SAKREBLE_H

#include <qwidget.h>

#include "alfabet.h"

#define DO_RUCHU_GRACZA 0
#define DO_RUCHU_KOMPUTERA 1
#define DO_WYBORU_GRACZY 2
#define DO_ROZPOCZECIA_PARTII 3
#define DO_ZAKONCZENIA_PARTII 4
#define DO_ZATWIERDZENIA_SLOWA 5
#define DO_ZASTAPIENIA_BLANKA 6

#define ILE_IDOW_W_MENU 10

#define GRA_NOWA_GRA_ID 0
#define RUCH_OK_ID 1
#define RUCH_WYMIEN_ID 2
#define RUCH_PAS_ID 3
#define GRA_KONIEC_PROGRAMU_ID 4
#define NARZEDZIA_SCIAGAWKA_ID 5
#define GRA_START_ID 6
#define GRACZ_DODAJ_ID 7
#define OPCJE_DORYSOWUJ_OGONKI_ID 8
#define GRACZ_O_GRACZACH_ID 9

class QPushButton;
class QLabel;
class QComboBox;
class QMenuBar;
class QPopupMenu;

class Plansza;
class Stojak;
class Punkty;
class Litery;
class Podswietlenie;
class Lampka;
class ZastapBlanka;
class Zostalo;
class Gracze;
class OGraczach;

struct wzorzec_struct;

class Sakreble : public QWidget
{
    Q_OBJECT

    public:
	Sakreble( QWidget *parent = 0 , const char *name = 0 );
	~Sakreble();

    public slots:
	void zaczynamyGre();
	void ruchKomputera();
	void obslugaOk( int );
	void obslugaWymiana( int );
	void graczSpasowal();
	void graczWymienia();
	void wyborGraczy();
	void graczowiSlowoZatwierdzono();
	void sprawdzamySlowo();
	void graczNacisnalOk();
	void zastapionoBlanka( char );
	void obslugaSciagawkiZMenu();
	void obslugaOgonkow();
	void imionaGraczyDoCombow();
	void obslugaCombo0( const QString & );
	void obslugaCombo1( const QString & );
	void pokazOGraczach();
	void zmajstrujComba();

    private:
	void sortujSlowo( char * , int );
	void wylosujLitery( char * , int );
	void czyscWzorce();
	int zliczSpacje( char * );
	void dodaj_wzorzec( int , int , char * , int );
	void dodaj_powiazanie( struct wzorzec_struct * , struct wzorzec_struct * );
	void dodaj_slowo( struct wzorzec_struct * , char * , int , int * , int );
	void inicjuj_wzorce();
	void inicjuj_litery();
	void pierwszy_ruch();
	void produkuj_wzorce_z_planszy( char );
	void produkuj_powiazania();
	int porownaj_pola_wzorcow( struct wzorzec_struct * , struct wzorzec_struct * );
	void pokolejkuj_wzorce();
	void wczytaj_slownik();
	void odrzuc_litere_ze_slowa( char * , int , char );
	struct wzorzec_struct *wybierz_najlepsze_slowo();
	void przejedz_slownik_wzorcami( char * , int );
	void machnij_slowo_na_plansze( struct wzorzec_struct * );
	int slowoJestWSlowniku( char * , int );
	int slowoZPlanszyJestWSlowniku( int , int , int );
	void znajdzDlugosci();
	int porownajSlowa( char * , char * , int );
	void pokazWidgety( int );
	void graczUkladaSlowo();
	void koniecPartii();
	void machnij_dolozone_plansze( struct wzorzec_struct * );
	void imionaGraczyDoCombo( int );
	void obslugaCombow( int , const QString & );

	QPushButton *quit, *start, *next, *ok, *wymien, *pas, *nextGame, *sprawdzButton;
	QPushButton *zatwierdzButton, *zostaloLiterButton;
	QComboBox *graczCombo[2];
	QLabel *label, *pozostaloLabel;
	QMenuBar *menu;
	QPopupMenu *menuGra, *menuRuch, *menuNarzedzia, *menuGracz, *menuOpcje;
	Plansza *plansza;
	Stojak *stojak;
	Alfabet alfabet;
	Punkty *punkty[2], *ten_ruch;
	Litery *literyGracza[2];
	Podswietlenie *podsw;
	Lampka *lampka[2];
	ZastapBlanka *zastapBlanka;
	Zostalo *zostalo;
	Gracze *gracze;
	OGraczach *oGraczach;

	char *slownik, *koniec_slownika;
	struct wzorzec_struct *wzorce[15][15][7][2], *pierwszy_wzorzec[15];
	struct wzorzec_struct *wzorzec_z_najlepszym_slowem;
	int ktoryGracz;	// Ktory gracz teraz ma sie ruszyc
	int ktoryDoSciagawki; // Jak gra czlowiek z komputerem, to to nie bedzie sie zmieniac
	char *dlugosci[15];	// Czesci slownika o odpowiednich dlugosciach
	int ile_pauz;
	int byl_kit;
	int idy_menu[ ILE_IDOW_W_MENU ];
};

#endif
