#include <stdio.h>

#include <qpainter.h>
#include <qwindefs.h>
#include <qfont.h>

#include "stojak.h"
#include "dupa.h"
#include "alfabet.h"

Stojak::Stojak( QWidget *parent , const char *name ) : QWidget( parent, name )
{
    for( int i=0; i<7; i++ )
    {
	litery[i] = PUSTE_POLE;
	do_wymiany[i] = PUSTE_POLE;
    }

    podswietlona = -1;
}

void Stojak::paintEvent( QPaintEvent *e )
{
    QPainter paint;
    QString s;
    QRect updateR = e->rect();

    paint.begin( this );

    paint.setPen( black );

    for( int i=0; i<15; i++ )
    {
	if( !updateR.intersects( QRect( i*30 + 1 , 1 , 28 , 28 ) ) )
	    continue;

	if( i != 7 )
	{
	    if( i < 7 )
	    {
		if( litery[i] != PUSTE_POLE )
		{
		    if( podswietlona == i )
			paint.setBrush( yellow );
		    else
			paint.setBrush( darkGray );

		    paint.drawRect( i*30 + 1 , 1 , 28 , 28 );

		    s.sprintf( "%c" , alfabet->duzaLitera( litery[i] ) );
		    paint.setFont( QFont( "Times" , 18 , QFont::Bold ) );
		    paint.drawText( i*30 + 1 , 1 , 26 , 26 , AlignCenter , s , 1 );

		    if( alfabet->nieMaPolskich() && alfabet->potrzebnyOgonek( litery[i] ) )
		    {
			s = tr( "%1" ).arg( alfabet->doogonkuj( litery[i] ) );

			int vert_offset = alfabet->gdzieVOgonek( litery[i] );
			int hor_offset  = alfabet->gdzieHOgonek( litery[i] );

			paint.drawText( i*30 - 1 + hor_offset , - 1 + vert_offset , s , 1 );
		    }

		    if( alfabet->dajPunktyLitery( litery[i] ) > 0 )
		    {
			s.sprintf( "%i" , alfabet->dajPunktyLitery( litery[i] ) );
			paint.setFont( QFont( "Times" , 10 , QFont::Bold ) );
			paint.drawText( i*30 + 19 , 16 , 10 , 10 , AlignCenter , s , 1 );
		    }
		}
		else
		{
		    paint.setBrush( gray );
		    paint.drawRect( i*30 + 1 , 1 , 28 , 28 );
		}
	    }
	    else
	    {
		if( do_wymiany[i-8] != PUSTE_POLE )
		{
		    if( podswietlona == i )
			paint.setBrush( yellow );
		    else
			paint.setBrush( darkGray );

		    paint.drawRect( i*30 + 1 , 1 , 28 , 28 );

		    s.sprintf( "%c" , alfabet->duzaLitera( do_wymiany[i-8] ) );
		    paint.setFont( QFont( "Times" , 18 , QFont::Bold ) );
		    paint.drawText( i*30 + 1 , 1 , 26 , 26 , AlignCenter , s , 1 );

		    if( alfabet->nieMaPolskich() && alfabet->potrzebnyOgonek( do_wymiany[i-8] ) )
		    {
			s = tr( "%1" ).arg( alfabet->doogonkuj( do_wymiany[i-8] ) );

			int vert_offset = alfabet->gdzieVOgonek( do_wymiany[i-8] );
			int hor_offset  = alfabet->gdzieHOgonek( do_wymiany[i-8] );

			paint.drawText( i*30 - 1 + hor_offset , - 1 + vert_offset , s , 1 );
		    }

		    if( alfabet->dajPunktyLitery( do_wymiany[i-8] ) > 0 )
		    {
			s.sprintf( "%i" , alfabet->dajPunktyLitery( do_wymiany[i-8] ) );
			paint.setFont( QFont( "Times" , 10 , QFont::Bold ) );
			paint.drawText( i*30 + 19 , 16 , 10 , 10 , AlignCenter , s , 1 );
		    }
		}
		else
		{
		    paint.setBrush( gray );
		    paint.drawRect( i*30 + 1 , 1 , 28 , 28 );
		}
	    }
	}
    }

    paint.end();
}

void Stojak::mousePressEvent( QMouseEvent *e )
{
    if ( e->button() != LeftButton )
	return;

    if( e->x() / 30 == 7 )
	return;

    if( e->x() / 30 < 7 )
	emit kliknietyStojak( e->x() / 30 );
    else
	emit kliknieteDoWymiany( e->x() / 30 - 8 );
}

void Stojak::ustawLitereNaStojaku( char l , int gdzie )
{
    if( litery[gdzie] != l )
    {
	litery[gdzie] = l;
	repaint( QRect( gdzie*30 + 1 , 1 , 28 , 28 ) );
    }
}

void Stojak::ustawLitereDoWymiany( char l , int gdzie )
{
    if( do_wymiany[gdzie] != l )
    {
	do_wymiany[gdzie] = l;
	repaint( QRect( ( gdzie + 8 )*30 + 1 , 1 , 28 , 28 ) );

	for( int i=0; i<7; i++ )
	    if( do_wymiany[i] != PUSTE_POLE )
	    {
    		emit moznaDoWymianyKlikac( true );
		return;
	    }

    	emit moznaDoWymianyKlikac( false );
    }
}

/*
 * Ustawia litery od lewej, pozostale miejsca wypuszcza
 */
void Stojak::ustawLiteryNaStojaku( char *l , int ile )
{
    for( int i=0; i<7; i++ )
	if( i<ile )
	    litery[i] = l[i];
	else
	    litery[i] = PUSTE_POLE;

    repaint( QRect( 0 , 0 , 220 , 30 ) );
}

void Stojak::podswietlLitereNaStojaku( int ktora )
{
    if( litery[ktora] == PUSTE_POLE )
	return;
    
    if( podswietlona == ktora )
	return;

    podswietlona = ktora;

    repaint( QRect( ktora*30 + 1 , 1 , 28 , 28 ) );
}

void Stojak::podswietlLitereDoWymiany( int ktora )
{
    if( do_wymiany[ktora] == PUSTE_POLE )
	return;
    
    if( podswietlona == ktora )
	return;

    podswietlona = ktora + 8;

    repaint( QRect( ( ktora + 8 )*30 + 1 , 1 , 28 , 28 ) );
}

void Stojak::zgasLitereNaStojaku()
{
    int ktora = podswietlona;
    podswietlona = -1;

    repaint( QRect( ktora * 30 + 1 , 1 , 28 , 28 ) );
}

void Stojak::zgasLitereDoWymiany()
{
    int ktora = podswietlona;
    podswietlona = -1;

    repaint( QRect( ktora * 30 + 1 , 1 , 28 , 28 ) );
}

void Stojak::zamienLiteryNaStojaku( int i , int j )
{
    char pom;

    if( i == j )
	return;

    pom = litery[i];
    litery[i] = litery[j];
    litery[j] = pom;

    repaint( QRect( i*30 + 1 , 1 , 28 , 28 ) );
    repaint( QRect( j*30 + 1 , 1 , 28 , 28 ) );
}

void Stojak::zamienLiteryDoWymiany( int i , int j )
{
    char pom;

    if( i == j )
	return;

    pom = do_wymiany[i];
    do_wymiany[i] = do_wymiany[j];
    do_wymiany[j] = pom;

    repaint( QRect( (i+8)*30 + 1 , 1 , 28 , 28 ) );
    repaint( QRect( (j+8)*30 + 1 , 1 , 28 , 28 ) );
}

int Stojak::saLiteryDoWymiany()
{
    for( int i=0; i<7; i++ )
	if( do_wymiany[i] != PUSTE_POLE )
	    return 1;

    return 0;
}

int Stojak::saLiteryNaStojaku()
{
    for( int i=0; i<7; i++ )
	if( litery[i] != PUSTE_POLE )
	    return 1;

    return 0;
}

void Stojak::zdejmijLiteryDoWymiany()
{
    for( int i=0; i<7; i++ )
	if( do_wymiany[i] != PUSTE_POLE )
	    ustawLitereDoWymiany( PUSTE_POLE , i );
}

