#include "valid.h"

MojIntValidator::MojIntValidator( QWidget *parent , const char *name ) :
    QIntValidator( parent , name )
{}

MojIntValidator::MojIntValidator( int b , int t , QWidget *parent , const char *name ) :
    QIntValidator( b , t , parent , name )
{}

void MojIntValidator::fixup( QString &input )
{
    if( input.toInt() > top() )
	input.setNum( top() );
    else
    {
	if( input.toInt() < bottom() )
	    input.setNum( bottom() );
    }
}

QValidator::State MojIntValidator::validate( QString &input , int &pos )
{
    int oldlen = strlen( input );

    input.setNum( input.toInt() );	// To usuwa literki

    if( oldlen != strlen( input ) )
	pos = strlen( input );

    if( input.toInt() >= bottom() && input.toInt() <= top() )
	return Valid;

    if( input.toInt() > top() )
    {
	fixup( input );
	return Valid;
    }

    if( input.toInt() < 0 && bottom() >= 0 )
    {
	fixup( input );
	return Valid;
    }

    if( input.toInt() > 0 && top() <= 0 )
    {
	fixup( input );
	return Valid;
    }

    return Acceptable;
}
