#include "zostalo.h"
#include "alfabet.h"
#include "litery.h"

#include "qpainter.h"
#include "qwindefs.h"
#include "qpushbt.h"

Zostalo::Zostalo( QWidget *parent , const char *name ) : QWidget( parent , name , WStyle_DialogBorder )
{
    alfabet = NULL;

    setMinimumSize( 510 , 160 );
    setMaximumSize( 510 , 160 );

    setCaption( "Pozostao liter" );

    ok = new QPushButton( "Zamknij", this, "ok" );
    ok->setGeometry( 260 , 135 , 100 , 20 );

    zMoimi = new QPushButton( "Z moimi literami", this, "zmoimi" );
    zMoimi->setGeometry( 150 , 135 , 100 , 20 );

    czy_ze_mna = 0;
    ktoryGracz = NULL;

    connect( ok , SIGNAL( clicked() ) , SIGNAL( kliknietoZamknij() ) );
    connect( zMoimi , SIGNAL( clicked() ) , SLOT( zmienZMoimi() ) );
}

void Zostalo::paintEvent( QPaintEvent * )
{
    QPainter paint;
    QString s;
    int ile;

    paint.begin( this );

    paint.setPen( black );
    paint.setFont( QFont( "Times" , 18 , QFont::Bold ) );

    for( int j=0; j<2; j++ )
	for( int i=0; i<17; i++ )
	{
	    if( j == 1 && i == 16 )
		continue;

	    ile =  alfabet->litera( (unsigned char)alfabet->literaAlfabetu( j*17 + i + 1 ) );

	    if( czy_ze_mna )
	    {
		ile += literyGracza[*ktoryGracz]->ileDanejLitery( alfabet->literaAlfabetu( j*17 + i + 1 ) );
	    }
	    ile += literyGracza[1-(*ktoryGracz)]->ileDanejLitery( alfabet->literaAlfabetu( j*17 + i + 1 ) );

	    if( ile > 0 )
		paint.setBrush( gray );
	    else
		paint.setBrush( darkGray );

	    paint.drawRect( i*30 + 1 + j*15 , j*70 + 1 , 28 , 28 );
	    paint.drawRect( i*30 + 1 + j*15 , j*70 + 31 , 28 , 28 );

	    s.sprintf( "%c" , alfabet->duzaLitera( alfabet->literaAlfabetu( j*17 + i + 1 ) ) );
	    paint.drawText( i*30 + 1 + j*15 , j*70 + 1 , 28 , 28 , AlignCenter , s , 1 );

	    if( alfabet->nieMaPolskich() && alfabet->potrzebnyOgonek( alfabet->literaAlfabetu( j * 17 + i + 1 ) ) );
	    {
		s = tr( "%1" ).arg( alfabet->doogonkuj( alfabet->literaAlfabetu( j * 17 + i + 1 ) ) );

		int vert_offset = alfabet->gdzieVOgonek( alfabet->literaAlfabetu( j * 17 + i + 1 ) );
		int hor_offset  = alfabet->gdzieHOgonek( alfabet->literaAlfabetu( j * 17 + i + 1 ) );

		paint.drawText( i*30 + hor_offset + j*15 , j*70 + vert_offset , s , 1 );
	    }

	    s.sprintf( "%d" , ile );
	    paint.drawText( i*30 + 1 + j*15 , j*70 + 31 , 28 , 28 , AlignCenter , s , 1 );
	}

    paint.end();
}

void Zostalo::zmienZMoimi()
{
    if( czy_ze_mna )
	zMoimi->setText( "Z moimi literami" );
    else
	zMoimi->setText( "Bez moich liter" );

    czy_ze_mna = !czy_ze_mna;

    repaint();
}
